#INCLUDE <hmg.ch>
#INCLUDE <PS_Posoft.ch>

FUNCTION ConvertNum2Letter(numero)
 local tabla:=array(20,3), numeros:=array(12), decimales:="", ;
       decenas:="", centenas:="", decmillar:="", cenmillar:="", ;
       GsNum2Letter:="", contador:=0

 tabla[ 1,1]:="UN"  ;tabla[ 1,2]:="DIEZ"    ;tabla[ 1,3]:="CIEN"
 tabla[ 2,1]:="DOS" ;tabla[ 2,2]:="VEINTE"  ;tabla[ 2,3]:="DOSCIENTOS"
 tabla[ 3,1]:="TRES"    ;tabla[ 3,2]:="TREINTA" ;tabla[ 3,3]:="TRESCIENTOS"
 tabla[ 4,1]:="CUATRO"  ;tabla[ 4,2]:="CUARENTA";tabla[ 4,3]:="CUATROCIENTOS"
 tabla[ 5,1]:="CINCO"   ;tabla[ 5,2]:="CINCUENTA";tabla[ 5,3]:="QUINIENTOS"
 tabla[ 6,1]:="SEIS"    ;tabla[ 6,2]:="SESENTA" ;tabla[ 6,3]:="SEISCIENTOS"
 tabla[ 7,1]:="SIETE"   ;tabla[ 7,2]:="SETENTA" ;tabla[ 7,3]:="SETECIENTOS"
 tabla[ 8,1]:="OCHO"    ;tabla[ 8,2]:="OCHENTA" ;tabla[ 8,3]:="OCHOCIENTOS"
 tabla[ 9,1]:="NUEVE"   ;tabla[ 9,2]:="NOVENTA" ;tabla[ 9,3]:="NOVECIENTOS"
 tabla[10,1]:="DIEZ"    ;tabla[10,2]:="CIENTO"  ;tabla[10,3]:="MIL"
 tabla[11,1]:="ONCE"    ;tabla[12,1]:="DOCE"    ;tabla[13,1]:="TRECE"
 tabla[14,1]:="CATORCE"  ;tabla[15,1]:="QUINCE" ;tabla[16,1]:="DIECISEIS"
 tabla[17,1]:="DIECISIETE";tabla[18,1]:="DIECIOCHO";tabla[19,1]:="DIECINUEVE"
 tabla[20,1]:="VEINTI"
 do case
    case valtype(numero)#"N"
        GsNum2Letter:=""
    case (numero<1 .and. numero>0)
        GsNum2Letter:="CERO PESOS "+substr(str(numero,15,2),14,2)+"/100 M.N."
    otherwise
        GsNum2Letter:=substr(str(numero,15,2),1,12)
        for contador=1 to 12
            numeros[13-contador]:=substr(GsNum2Letter,contador,1)
        next
        GsNum2Letter:=""
        decimales:=substr(str(numero,15,2),14,2)+"/100 M.N."
        do case
            case (val(numeros[1])=0  .and. val(numeros[2])=0)
                decenas:=""
            case (val(numeros[1])>0  .and. val(numeros[2])=0)
                decenas:=tabla[val(numeros[1]),1]
            case (val(numeros[1])<10 .and. val(numeros[2])=1)
                decenas:=tabla[10+val(numeros[1]),1]
            case (val(numeros[1])>0  .and. val(numeros[2])=2)
                decenas:=tabla[20,1]+tabla[val(numeros[1]),1]
            case (val(numeros[1])>0  .and. val(numeros[2])>2)
                decenas:=tabla[val(numeros[2]),2]+" Y "+tabla[val(numeros[1]),1]
            otherwise
                decenas:=tabla[val(numeros[2]),2]
        end
        do case
            case (val(numeros[3])=0  .and. (val(numeros[2])=0 .or. val(numeros[2])>0))
                centenas:=""
            case (val(numeros[3])=1  .and. (val(numeros[2])>0 .or. val(numeros[1])>0))
                centenas:=tabla[10,2]
            case (val(numeros[3])>0  .and. val(numeros[2])=0 .and. val(numeros[1])=0)
                centenas:=tabla[val(numeros[3]),3]
            otherwise
                centenas:=tabla[val(numeros[3]),3]
        end
        do case
            case (val(numeros[4])=0  .and. val(numeros[5])=0)
                decmillar:=""
            case (val(numeros[4])>0  .and. val(numeros[5])=0)
                decmillar:=tabla[val(numeros[4]),1]+" MIL"
            case (val(numeros[4])<10 .and. val(numeros[5])=1)
                decmillar:=tabla[10+val(numeros[4]),1]+" MIL"
            case (val(numeros[4])>0  .and. val(numeros[5])=2)
                decmillar:=tabla[20,1]+tabla[val(numeros[4]),1]+" MIL"
            case (val(numeros[4])>0  .and. val(numeros[5])>2)
                decmillar:=tabla[val(numeros[5]),2]+" Y "+tabla[val(numeros[4]),1]+" MIL"
            otherwise
                decmillar:=tabla[val(numeros[5]),2]+" MIL"
        end
        do case
            case (val(numeros[6])=0  .and. (val(numeros[5])=0 .or. val(numeros[5])>0))
                cenmillar:=""
            case (val(numeros[6])=1  .and. (val(numeros[5])>0 .or. val(numeros[4])>0))
                cenmillar:=tabla[10,2]
            case (val(numeros[6])>0  .and. val(numeros[5])=0 .and. val(numeros[4])=0)
                cenmillar:=tabla[val(numeros[6]),3]+" MIL"
            otherwise
                cenmillar:=tabla[val(numeros[6]),3]
        end
        GsNum2Letter:=cenmillar+" "+decmillar+" "+centenas+" "+decenas+" PESOS "+decimales
 end

return GsNum2Letter
