﻿#INCLUDE <hmg.ch>
#INCLUDE "hbver.ch"
#INCLUDE <PS_Posoft.ch>

PROCEDURE ItemMaintenanceProvider
   PRIVATE GbIsNew := .T.
   PRIVATE aGetTableData := {}
   PRIVATE LnCurrencyId := 0
   PRIVATE LsProviderName := ""
   PRIVATE LnGroupId := 0
   PRIVATE LnSubGroupId := 0
   PRIVATE LnProviderId := 0
   LoadMyData()
   SET TOOLTIPSTYLE BALLOON
   IF IsWindowActive (Frm_ItemProvider)
      MsgStop("Ya esta en en uso esta opción","ERROR")
      RETURN NIL
   ELSE
      LOAD WINDOW Frm_ItemProvider
      END WINDOW
			IF .NOT. ConectMe()
			  RETURN
			ENDIF
      SwitchItemProvider(0)
      CENTER WINDOW Frm_ItemProvider
      ACTIVATE WINDOW Frm_ItemProvider
   ENDIF

   PROCEDURE SwitchItemProvider(PnKindSwitch)
      DO CASE
         CASE PnKindSwitch == 0     // Default
            Frm_ItemProvider.Btn_New.Enabled := .T.
            Frm_ItemProvider.Btn_Edit.Enabled := .F.
            Frm_ItemProvider.Btn_Delete.Enabled := .F.
            Frm_ItemProvider.Btn_Back.Enabled := .F.
            Frm_ItemProvider.Btn_Save.Enabled := .F.
            Frm_ItemProvider.Btn_SeeDetail.Enabled := .T.
            Frm_ItemProvider.Btn_FillItUp.Enabled := .T.
            Frm_ItemProvider.Btn_Print.Enabled := .F.
            Frm_ItemProvider.Btn_Exit.Enabled := .T.
            Frm_ItemProvider.Fra_FindIndividualData.Visible := .F.
            Frm_ItemProvider.Txt_FindIndividual.Visible := .F.
            Frm_ItemProvider.Btn_FindIndividual.Visible := .F.
            
            Frm_ItemProvider.Btn_FindProvider.Enabled := .F.
            Frm_ItemProvider.Btn_FindItem.Enabled := .F.            
            Frm_ItemProvider.Txt_FindIndividual.Value := ""
            Frm_ItemProvider.Txt_ProviderName.Value := ""
            Frm_ItemProvider.Txt_ItemId.Value := ""
            Frm_ItemProvider.Txt_ItemDesc.Value := ""
            Frm_ItemProvider.Txt_Measure.Value := ""
            Frm_ItemProvider.Txt_Presentacion.Value := ""               
            Frm_ItemProvider.Txt_ItemCost.Value := 0    
            Frm_ItemProvider.Txt_ItemTax.Value := 0
            Frm_ItemProvider.Txt_DeliveryDay.Value := 0      
            Frm_ItemProvider.Txt_Revision.Value := ""       

            Frm_ItemProvider.Txt_FindIndividual.Enabled := .F.
            Frm_ItemProvider.Txt_ItemId.Enabled := .F.
            Frm_ItemProvider.Txt_ItemDesc.Enabled := .F.  
            Frm_ItemProvider.Txt_Measure.Enabled := .F.
            Frm_ItemProvider.Txt_Presentacion.Enabled := .F.              
            Frm_ItemProvider.Txt_ItemCost.Enabled := .F. 
            Frm_ItemProvider.Txt_ItemTax.Enabled := .F.
            Frm_ItemProvider.Txt_DeliveryDay.Enabled := .F.    
            Frm_ItemProvider.Txt_Revision.Enabled := .F.
            
            Frm_ItemProvider.Btn_New.SetFocus

         CASE PnKindSwitch == 1     // New despu�s de verificar "ExistsItem"
            Frm_ItemProvider.Btn_New.Enabled := .F.
            Frm_ItemProvider.Btn_Edit.Enabled := .F.
            Frm_ItemProvider.Btn_Delete.Enabled := .F.
            Frm_ItemProvider.Btn_Exit.Enabled := .F.
            Frm_ItemProvider.Btn_Print.Enabled := .F.
            Frm_ItemProvider.Btn_SeeDetail.Enabled := .F.
            Frm_ItemProvider.Btn_Save.Enabled := .T.
            Frm_ItemProvider.Btn_Back.Enabled := .T.
            Frm_ItemProvider.Btn_FillItUp.Enabled := .F.

            Frm_ItemProvider.Btn_FindItem.Enabled := .T.
            Frm_ItemProvider.Txt_FindIndividual.Enabled := .T.
            Frm_ItemProvider.Txt_ItemId.Enabled := .F.
            Frm_ItemProvider.Txt_ItemDesc.Enabled := .F.
            Frm_ItemProvider.Txt_Measure.Enabled := .T.
            Frm_ItemProvider.Txt_Presentacion.Enabled := .T.              
            Frm_ItemProvider.Txt_ItemCost.Enabled := .T.       
            Frm_ItemProvider.Txt_ItemTax.Enabled := .T.
            Frm_ItemProvider.Txt_DeliveryDay.Enabled := .T.     
            Frm_ItemProvider.Txt_Revision.Enabled := .T.
            
            Frm_ItemProvider.Txt_Measure.SetFocus

         CASE PnKindSwitch == 2     // Edit
            Frm_ItemProvider.Btn_New.Enabled := .F.
            Frm_ItemProvider.Btn_Edit.Enabled := .F.
            Frm_ItemProvider.Btn_Delete.Enabled := .F.
            Frm_ItemProvider.Btn_Back.Enabled := .T.
            Frm_ItemProvider.Btn_Save.Enabled := .F.
            Frm_ItemProvider.Btn_SeeDetail.Enabled := .F.
            Frm_ItemProvider.Btn_FillItUp.Enabled := .F.
            Frm_ItemProvider.Btn_Print.Enabled := .F.
            Frm_ItemProvider.Btn_Exit.Enabled := .F.

            Frm_ItemProvider.Btn_FindItem.Enabled := .T.
            Frm_ItemProvider.Txt_FindIndividual.Enabled := .T.
            Frm_ItemProvider.Txt_ItemId.Enabled := .T.
            Frm_ItemProvider.Txt_ItemDesc.Enabled := .T.      
            Frm_ItemProvider.Txt_Measure.Value := .T.
            Frm_ItemProvider.Txt_Presentacion.Value := .T.              
            Frm_ItemProvider.Txt_ItemCost.Enabled := .T.
            Frm_ItemProvider.Txt_ItemTax.Enabled := .T.
            Frm_ItemProvider.Txt_DeliveryDay.Enabled := .T.         
            Frm_ItemProvider.Txt_Revision.Enabled := .T.

            Frm_ItemProvider.Btn_FindProvider.SetFocus

         CASE PnKindSwitch == 3  // Nuevo registro cuando dan click en el boton de nuevo
            GbIsNew := .T.
            Frm_ItemProvider.Grd_ItemProvider.DeleteAllItems
            Frm_ItemProvider.Btn_New.Enabled := .F.
            Frm_ItemProvider.Btn_Edit.Enabled := .F.
            Frm_ItemProvider.Btn_Delete.Enabled := .F.
            Frm_ItemProvider.Btn_Exit.Enabled := .F.
            Frm_ItemProvider.Btn_Print.Enabled := .F.
            Frm_ItemProvider.Btn_SeeDetail.Enabled := .F.
            Frm_ItemProvider.Btn_Save.Enabled := .T.
            Frm_ItemProvider.Btn_Back.Enabled := .T.
            Frm_ItemProvider.Btn_FillItUp.Enabled := .F.

            Frm_ItemProvider.Btn_FindProvider.Enabled := .T.
            Frm_ItemProvider.Txt_FindIndividual.Value := ""
            Frm_ItemProvider.Txt_ItemId.Value := ""
            Frm_ItemProvider.Txt_ItemDesc.Value := ""
            Frm_ItemProvider.Txt_Measure.Value := ""  
            Frm_ItemProvider.Txt_Presentacion.Value := ""       
            Frm_ItemProvider.Img_Item.PICTURE := ""
            Frm_ItemProvider.Txt_ItemCost.Value := 0
            Frm_ItemProvider.Txt_ItemTax.Value := 0
            Frm_ItemProvider.Txt_ProviderName.Value := ""  
            Frm_ItemProvider.Txt_DeliveryDay.Value := 0                 
            Frm_ItemProvider.Txt_Revision.Value := ""
            
            Frm_ItemProvider.Txt_FindIndividual.Enabled := .T.
            Frm_ItemProvider.Txt_ItemId.Enabled := .T.
            Frm_ItemProvider.Txt_ItemDesc.Enabled := .T.
            Frm_ItemProvider.Txt_ItemCost.Enabled := .T.
            Frm_ItemProvider.Txt_ItemTax.Enabled := .T. 
            Frm_ItemProvider.Txt_DeliveryDay.Enabled := .T.        
            Frm_ItemProvider.Txt_Revision.Enabled := .T.
            
            Frm_ItemProvider.Btn_FindProvider.SetFocus

      ENDCASE
   RETURN

FUNCTION GetItemProvider
// Presenta a los proveedores.
   IF LnProviderId = 0
      FindProviderItem()
   ELSE
      IF .NOT. MsgYesNo("¿Desea continuar consultando artículos del proveedor?"+HB_OSNewLine()+LsProviderName)
         FindProviderItem()
      ENDIF
   ENDIF     
      
// Lee y carga los datos de los articulos del priveedor seleccionado       
      GsReadQuery := "SELECT ip.Provider_Id, "        // 1
      GsReadQuery += "ip.Item_Cd, "                   // 2
      GsReadQuery += "i.Name, "                       // 3
      GsReadQuery += "ip.Unit_Measure, "              // 4
      GsReadQuery += "ip.Presentacion, "              // 5
      GsReadQuery += "ip.Tax_Percentage, "            // 6
      GsReadQuery += "ip.Cost, "                      // 7
      GsReadQuery += "i.Picture_Path, "               // 8
      GsReadQuery += "ip.Delivery_Day, "              // 9  
      GsReadQuery += "ip.Revision "                   // 10
      GsReadQuery += "FROM item_provider ip "
      GsReadQuery += "INNER JOIN Item i on i.Item_Cd = ip.item_Cd "
      GsReadQuery += "WHERE ip.Is_Visible = 1 "
      GsReadQuery += "AND ip.Provider_Id = " + C2SQL(LnProviderId)
      GsReadQuery += " ORDER BY i.Name "

   IF TryToLock()
    aGetTableData := ReadData (GsReadQuery)
    DeleteFileLock()
   ENDIF
    
   IF LEN (aGetTableData) > 0
	  FillItUpItemPro(aGetTableData) 
    Frm_ItemProvider.Txt_Measure.Enabled := .F.
    Frm_ItemProvider.Txt_Presentacion.Enabled := .F.              
    Frm_ItemProvider.Txt_ItemCost.Enabled := .F.       
    Frm_ItemProvider.Txt_ItemTax.Enabled := .F.
    Frm_ItemProvider.Txt_DeliveryDay.Enabled := .F. 
	 ELSE                        
	  MsgExclamation ( "No existe ningún articulo en la base de datos." )
	 ENDIF
	 IF Frm_ItemProvider.Grd_ItemProvider.ItemCount > 0
	  Frm_ItemProvider.Btn_Edit.Enabled := .T.
	  Frm_ItemProvider.Btn_Delete.Enabled := .T.
	  Frm_ItemProvider.Btn_Print.Enabled := .T.
	 ELSE
	  Frm_ItemProvider.Btn_Edit.Enabled := .F.
	  Frm_ItemProvider.Btn_Delete.Enabled := .F.
	  Frm_ItemProvider.Btn_Print.Enabled := .F.
	 ENDIF
RETURN(aGetTableData)

PROCEDURE FillItUpItemPro
	 Frm_ItemProvider.Grd_ItemProvider.DeleteAllItems
	 FOR i := 1 TO LEN (aGetTableData)
			Frm_ItemProvider.Grd_ItemProvider.AddItem ( {aGetTableData[i,1], +;
                  aGetTableData[i,2], +;
                  aGetTableData[i,3], +;
                  aGetTableData[i,4], +;                           
                  aGetTableData[i,5], +;
                  aGetTableData[i,6], +;
                  aGetTableData[i,7], +;
                  aGetTableData[i,8], +;
                  aGetTableData[i,9], +;
                  aGetTableData[i,10] })
	 NEXT i
	 IF Frm_ItemProvider.Grd_ItemProvider.ItemCount > 0
			Frm_ItemProvider.Btn_Edit.Enabled := .T.
			Frm_ItemProvider.Btn_Delete.Enabled := .T.
			Frm_ItemProvider.Btn_Print.Enabled := .T.
	 ELSE
			Frm_ItemProvider.Btn_Edit.Enabled := .F.
			Frm_ItemProvider.Btn_Delete.Enabled := .F.
			Frm_ItemProvider.Btn_Print.Enabled := .F.
	 ENDIF
RETURN
   
 PROCEDURE IndividualItemProvider
		 Frm_ItemProvider.Btn_Back.Enabled := .T.
		 Frm_ItemProvider.Btn_Exit.Enabled := .F.
		 Frm_ItemProvider.Btn_SeeDetail.Enabled := .T.
		 Frm_ItemProvider.Btn_New.Enabled := .F.
		 Frm_ItemProvider.Btn_FillItUp.Enabled := .F.
		 Frm_ItemProvider.Fra_FindIndividualData.Visible := .T.
		 Frm_ItemProvider.Txt_FindIndividual.Visible := .T.
		 Frm_ItemProvider.Btn_FindIndividual.Visible := .T.
		 Frm_ItemProvider.Txt_FindIndividual.Enabled:= .T.
		 Frm_ItemProvider.Txt_FindIndividual.SetFocus
 RETURN

PROCEDURE FindIndividuaItemProvider
	 Frm_ItemProvider.Btn_New.Enabled := .F.
	 Frm_ItemProvider.Btn_FillItUp.Enabled := .F.
	 Frm_ItemProvider.Btn_Delete.Enabled := .T.
	 Frm_ItemProvider.Btn_Edit.Enabled := .T.
	 Frm_ItemProvider.Btn_Back.Enabled := .T.
	 Frm_ItemProvider.Btn_SeeDetail.Enabled := .T.
	 Frm_ItemProvider.Btn_Print.Enabled := .T.
	 Frm_ItemProvider.Fra_FindIndividualData.Visible := .T.
	 Frm_ItemProvider.Txt_FindIndividual.Visible := .T.
	 LsToSearch := ALLTRIM ( Frm_ItemProvider.Txt_FindIndividual.Value )    
   
   GsReadQuery := "SELECT ip.Provider_Id, "        // 1
   GsReadQuery += "ip.Item_Cd, "                   // 2
   GsReadQuery += "i.Name, "                       // 3
   GsReadQuery += "ip.Unit_Measure, "              // 4
   GsReadQuery += "ip.Presentacion, "              // 5
   GsReadQuery += "ip.Tax_Percentage, "            // 6
   GsReadQuery += "ip.Cost, "                      // 7
   GsReadQuery += "i.Picture_Path, "               // 8
   GsReadQuery += "ip.Delivery_Day, "              // 9  
   GsReadQuery += "ip.Revision "                  // 10
   GsReadQuery += "FROM item_provider ip "
   GsReadQuery += "INNER JOIN Item i on i.Item_Cd = ip.item_Cd "
   GsReadQuery += "WHERE ip.Is_Visible = 1 "
   GsReadQuery += "AND ip.Provider_Id = " + C2SQL(LnProviderId)   
   GsReadQuery += " AND i.Name LIKE '%" + LsToSearch + "%' "
   GsReadQuery += "ORDER BY i.Name"

	 IF TryToLock()
			aGetTableData := ReadData (GsReadQuery)
			DeleteFileLock()
	 ENDIF
	 
	 IF LEN (aGetTableData) > 0
		 FillItUpItemPro(aGetTableData)
	 ELSE
		 MsgExclamation ( "No se encontro articulos para ese proveedor." )
		 Frm_ItemProvider.Txt_FindIndividual.SetFocus
		 RETURN
	 ENDIF
RETURN                                            

   PROCEDURE SaveItemProvider
      GdDateSQL := "DATE('NOW')"
      GsTimeSQL := "TIME('NOW','LOCALTIME')"
        LsName := "'"+ ALLTRIM ( Frm_ItemProvider.Txt_ItemDesc.Value ) + "'"
      IF CheckBeforeSaveItemProvider()       
			  IF GbIsNew
				  GsQueryInsert := "INSERT INTO Item_Provider ("        
          GsQueryInsert += "Provider_id, "           
          GsQueryInsert += "Item_Cd, "
          GsQueryInsert += "Unit_Measure, "
          GsQueryInsert += "Presentacion, "   
          GsQueryInsert += "Tax_Percentage, "
          GsQueryInsert += "Cost, " 
          GsQueryInsert += "Delivery_Day, "
          GsQueryInsert += "Revision, "
          GsQueryInsert += "Is_Visible, "
          GsQueryInsert += "Prog_Name, "
          GsQueryInsert += "Entry_Date, "
          GsQueryInsert += "Entry_Time) VALUES (" + C2SQL(LnProviderId) + ", "      
          GsQueryInsert += C2SQL (Frm_ItemProvider.Txt_ItemId.Value) + ", "
          GsQueryInsert += C2SQL(Frm_ItemProvider.Txt_Measure.Value) + ", "
          GsQueryInsert += C2SQL(Frm_ItemProvider.Txt_Presentacion.Value) + ", "
          GsQueryInsert += C2SQL(Frm_ItemProvider.Txt_ItemTax.Value) + ", "
          GsQueryInsert += C2SQL(Frm_ItemProvider.Txt_ItemCost.Value) + ", "
          GsQueryInsert += C2SQL(Frm_ItemProvider.Txt_DeliveryDay.Value) + ", " 
          GsQueryInsert += C2SQL(Frm_ItemProvider.Txt_Revision.Value) + ", "       
          GsQueryInsert += C2SQL (1) + ", "
          GsQueryInsert += C2SQL(PROCNAME()) + ","
          GsQueryInsert += GdDateSQL+", "
          GsQueryInsert += GsTimeSQL +")"
        ELSE
          GsQueryInsert := "UPDATE Item_Provider SET "
          GsQueryInsert += "Unit_Measure = " + C2SQL(Frm_ItemProvider.Txt_Measure.Value) + ", " 
          GsQueryInsert += "Presentacion = " + C2SQL(Frm_ItemProvider.Txt_Presentacion.Value) + ", " 
          GsQueryInsert += "Tax_Percentage = " + C2SQL(Frm_ItemProvider.Txt_ItemTax.Value) + ", "
          GsQueryInsert += "Cost = " + C2SQL(Frm_ItemProvider.Txt_ItemCost.Value) + ", "
          GsQueryInsert += "Delivery_Day =  " + C2SQL(Frm_ItemProvider.Txt_DeliveryDay.Value) + ", "
          GsQueryInsert += "Revision = " + C2SQL(Frm_ItemProvider.Txt_Revision.Value) + ", "
          GsQueryInsert += "Prog_Name = " + C2SQL(PROCNAME()) + ", "
          GsQueryInsert += "Modify_Date = " + GdDateSQL + ", "
          GsQueryInsert += "Modify_Time = " + GsTimeSQL + " "
          GsQueryInsert += "WHERE Item_Cd = " + C2SQL(Frm_ItemProvider.Txt_ItemId.Value)  
          GsQueryInsert += "AND Provider_id = " + C2SQL(LnProviderId)  
         ENDIF
         
			IF TryToLock()
				 IF BeforeSave(GsQueryInsert)
					MsgInfo ( IIF (GbIsNew,"Registro insertado o actualizado.","Registro actualizado"))
				   DeleteFileLock()
				 ELSE
					MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
				 ENDIF   
			ENDIF
			SwitchItemProvider(0)
      ENDIF
   RETURN

PROCEDURE EditItemProvier
	 IF Frm_ItemProvider.Grd_ItemProvider.Value = 0
	  GbIsNew := .T.
	   MsgInfo("Seleccione un articulo para su edición")
	  Frm_ItemProvider.Grd_ItemProvider.SetFocus
	  RETURN
	 ELSE
    GbIsNew := .F.
    GetOneItemProvider()
	 ENDIF
RETURN

   PROCEDURE DeleteItemProvider
      LsItemID := C2SQL(ColumnGridValue( "Grd_ItemProvider", "Frm_ItemProvider", 1))
      GsReadQuery :="SELECT Item_Cd  FROM Item WHERE Item_Cd = &LsItemId AND Provider_id = " + C2SQL(LnProviderId)    
      IF TryToLock()
        aGetTableData := ReadData (GsReadQuery)
        DeleteFileLock()
      ENDIF
      
      IF LEN (aGetTableData) > 0
         Frm_ItemProvider.Txt_ItemDesc.Value := aGetTableData[1,2]
         IF MsgYesNo("¿Desea eliminar al articulo?:"+HB_OSNewLine()+ Frm_ItemProvider.Txt_ItemDesc.Value,"¡Borrar!")
            //Frm_ItemProvider.Grd_ItemProvider.DeleteItem(Frm_ItemProvider.Grd_ItemProvider.Value)
            GsQueryDelete :="DELETE FROM Item WHERE Item_Cd = &LsItemID"
            IF TryToLock()
              IF BeforeSave(GsQueryDelete)
                Frm_ItemProvider.Grd_ItemProvider.DeleteItem(Frm_ItemProvider.Grd_ItemProvider.Value)              
                MsgInfo ( "Registro ha sido eliminado.")
                DeleteFileLock()
            ELSE
               MsgExclamation ("Error al tratar de borrar el cliente.")
            ENDIF
         ENDIF
        ENDIF 
      ENDIF
   RETURN

PROCEDURE GetOneItemProvider    
   GsReadQuery := "SELECT ip.Provider_Id, "        // 1
   GsReadQuery += "ip.Item_Cd, "                   // 2
   GsReadQuery += "i.Name, "                       // 3
   GsReadQuery += "ip.Unit_Measure, "              // 4
   GsReadQuery += "ip.Presentacion, "              // 5
   GsReadQuery += "ip.Tax_Percentage, "            // 6
   GsReadQuery += "ip.Cost, "                      // 7
   GsReadQuery += "i.Picture_Path, "               // 8
   GsReadQuery += "ip.Delivery_Day,"               // 9
   GsReadQuery += "ip.Revision "                  // 10 
   GsReadQuery += "FROM item_provider ip "
   GsReadQuery += "INNER JOIN Item i on i.Item_Cd = ip.item_Cd "
   GsReadQuery += "WHERE ip.Is_Visible = 1 "
   GsReadQuery += "AND ip.Provider_Id = " + C2SQL(VAL(ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",1)))   
   GsReadQuery += " AND ip.Item_Cd = "+C2SQL(ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",2)) 
   IF TryToLock()
      aGetTableData := ReadData (GsReadQuery)
      DeleteFileLock()
   ENDIF
      
   IF LEN (aGetTableData) > 0      
      Frm_ItemProvider.Img_Item.PICTURE := ""
      LnProviderId := VAL(ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",1))
      Frm_ItemProvider.Txt_ItemId.Value := ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",2)
      Frm_ItemProvider.Txt_ItemDesc.Value := ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",3)
      Frm_ItemProvider.Txt_Measure.Value := ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",4)
      Frm_ItemProvider.Txt_Presentacion.Value := ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",5)
      Frm_ItemProvider.Txt_ItemTax.Value := VAL(ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",6))
      Frm_ItemProvider.Txt_ItemCost.Value := VAL(ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",7)) 
      Frm_ItemProvider.Img_Item.PICTURE := ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",8)       
      Frm_ItemProvider.Txt_DeliveryDay.Value :=  VAL(ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",9))
      Frm_ItemProvider.Txt_Revision.Value := ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",10)
      SwitchItemProvider(1)
   ELSE
      MsgExclamation ("No se encontro ese codigo de articulo para ese proveedor.")
   ENDIF  
RETURN

PROCEDURE ShowItemDetailProvider
  Frm_ItemProvider.Img_Item.PICTURE := ""
  LnProviderId := VAL(ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",1))
  Frm_ItemProvider.Txt_ItemId.Value := ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",2)
  Frm_ItemProvider.Txt_ItemDesc.Value := ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",3)
  Frm_ItemProvider.Txt_Measure.Value := ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",4)
  Frm_ItemProvider.Txt_Presentacion.Value := ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",5)
  Frm_ItemProvider.Txt_ItemTax.Value := VAL(ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",6))
  Frm_ItemProvider.Txt_ItemCost.Value := VAL(ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",7)) 
  Frm_ItemProvider.Img_Item.PICTURE := ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",8) 
  Frm_ItemProvider.Txt_DeliveryDay.Value :=  VAL(ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",9)) 
  Frm_ItemProvider.Txt_Revision.Value := ColumnGridValue("Grd_ItemProvider", "Frm_ItemProvider",10)
RETURN

  PROCEDURE FindProviderItem
    LnProviderId := GnData1 := 0
    LsProviderName := GsData1 := ""
    Frm_ItemProvider.Txt_Measure.Value := ""   
    Frm_ItemProvider.Txt_ProviderName.Value := ""
    Frm_ItemProvider.Title := ""     
     
    ShowProvider()
    LnProviderId := GnData1
    Frm_ItemProvider.Txt_ProviderName.Value := GsData1
    Frm_ItemProvider.Title := "Articulos del provedor "+UPPER(GsData1)
    LsProviderName := UPPER(GsData1)    
    Frm_ItemProvider.Btn_FindItem.Enabled := .T.
    Frm_ItemProvider.Btn_FindItem.SetFocus 
  RETURN

PROCEDURE DeclineProvider
	 SwitchItemProvider(0)
	 Frm_ItemProvider.Grd_ItemProvider.DeleteAllItems
		IF Frm_ItemProvider.Grd_ItemProvider.ItemCount > 0
			Frm_ItemProvider.Btn_Edit.Enabled := .T.
			Frm_ItemProvider.Grd_ItemProvider.Value := 1
			Frm_ItemProvider.Grd_ItemProvider.SetFocus
	 ELSE
			Frm_ItemProvider.Grd_ItemProvider.Enabled := .F.
			Frm_ItemProvider.Btn_Edit.Enabled := .F.
			Frm_ItemProvider.Btn_New.Enabled := .T.
			Frm_ItemProvider.Btn_New.SetFocus
	 ENDIF
RETURN

PROCEDURE FindItemsProvider
   Frm_itemprovider.Txt_ItemId.Value := ""
   Frm_ItemProvider.Txt_ItemDesc.Value := ""
   Frm_ItemProvider.Txt_Measure.Value := ""   
   GsData1 := GsData2 := GsData3 := ""
   ShowItems()
   Frm_itemprovider.Txt_ItemId.Value := GsData1
   Frm_ItemProvider.Txt_ItemDesc.Value := GsData2 
   Frm_ItemProvider.Txt_Measure.Value := GsData3
   IF ExistsItemProvider()   
      SwitchItemProvider(1)
   ELSE
      Frm_ItemProvider.Btn_FindItem.SetFocus 
   ENDIF    
RETURN

PROCEDURE ItemExitProvider
	 Frm_ItemProvider.Release
RETURN

FUNCTION CheckBeforeSaveItemProvider
	 LOCAL LbReturn := .T.
    IF EMPTY(Frm_ItemProvider.Txt_ItemId.Value) .OR.  EMPTY (Frm_ItemProvider.Txt_ItemDesc.Value)
			 MsgExclamation ( "Ingresa el código de articulo y/o descripcion" , "¡Error!" )
			 Frm_ItemProvider.Txt_ItemId.SetFocus
			 RETURN(.F.) 
    ENDIF
    
    IF .NOT. EMPTY(Frm_ItemProvider.Txt_ItemId.Value) .AND. GbIsNew
			 GsReadQuery := "SELECT Item_Cd FROM item_provider WHERE "
			 GsReadQuery += "Item_Cd = " + C2SQL(ALLTRIM(Frm_ItemProvider.Txt_ItemId.Value))
			 GsReadQuery += " AND Provider_id = " + C2SQL(LnProviderId)
			 IF TryToLock()
				aCheckData := ReadData(GsReadQuery)
				DeleteFileLock()
			 ENDIF
					
			IF LEN(aCheckData) > 0
				MsgExclamation("Ya existe ese código de artículo en la base de datos,"+HB_OSNewLine()+;
									"teclea uno válido.","¡Error!")
				Frm_ItemProvider.Txt_ItemId.SetFocus
				RETURN(.F.)
			ENDIF
    ENDIF
RETURN ( LbReturn )

FUNCTION ExistsItemProvider
   LOCAL LbReturn := .T.
   GsReadQuery := "SELECT Item_Cd FROM item_provider WHERE Item_Cd = "
   GsReadQuery += C2SQL(Frm_ItemProvider.Txt_ItemId.Value) +" AND Provider_id = "
   GsReadQuery += C2SQL(LnProviderId)
   IF TryToLock()
      aCheckData := ReadData(GsReadQuery)
      DeleteFileLock()
   ENDIF
					
   IF LEN(aCheckData) > 0
      MsgExclamation("El articulo: "+HB_OSNewLine()+;
                     Frm_ItemProvider.Txt_ItemId.Value+HB_OSNewLine()+;
                     "Ya existe para el proveedor:"+HB_OSNewLine()+;
                     LsProviderName,"Error")
      LbReturn := .F.
   ENDIF

RETURN ( LbReturn )
RETURN

RETURN
