#INCLUDE <hmg.ch>
#INCLUDE <PS_Posoft.ch>

PROCEDURE DataEntryOwner
   SET TOOLTIPSTYLE BALLOON
   IF IsWindowActive (Frm_Owner)
      MsgStop("Ya esta en en uso esta opcin","ERROR")
      RETURN NIL
   ELSE
      LOAD WINDOW Frm_Owner
      END WINDOW
      GsStateName := GsCityName := ""
      OwnerSwitchCia(0)
      CheckOwnerData()
      CENTER WINDOW Frm_Owner
      ACTIVATE WINDOW Frm_Owner
   ENDIF

   PROCEDURE CheckOwnerData
      IF ConectMe()
         GsReadQuery := "SELECT "
         GsReadQuery += "o.Name, "                 // 1
         GsReadQuery += "o.Address_1, "                  // 2
         GsReadQuery += "o.Address_2, "                  // 3
         GsReadQuery += "o.Country_Id, "                 // 4
         GsReadQuery += "o.State_Id, "                   // 5
         GsReadQuery += "o.City_Id, "                    // 6
         GsReadQuery += "o.Postal_Code, "                // 7
         GsReadQuery += "o.Code_Area, "                  // 8
         GsReadQuery += "o.Phone_Office, "               // 9
         GsReadQuery += "o.Fiscal_Id, "                  //10
         GsReadQuery += "o.E_mail, "                     //11 
         GsReadQuery += "o.URL, "                        //12
         GsReadQuery += "o.Logo_Owner, "                 //13
         GsReadQuery += "IFNULL(s.Name,''), "      //14
         GsReadQuery += "IFNULL(c.Name,''), "       //15
         GsReadQuery += "IFNULL(o.Global_Tax_Percen, 0) "         //16
         GsReadQuery += "FROM Owner AS o "
         GsReadQuery += "LEFT JOIN STATES AS s ON o.State_Id = s.State_Id "
         GsReadQuery += "LEFT JOIN CITIES AS c ON o.City_Id = c.City_Id"
         
         IF TryToLock()
          aTableOwner := ReadData (GsReadQuery)
          DeleteFileLock()
         ENDIF
      ELSE
        RETURN
      ENDIF
			
			IF LEN (aTableOwner) = 0
          GsIsNew := .T.
          Frm_Owner.Txt_OwnerName.Value := ""
          Frm_Owner.Txt_Address1.Value := ""
          Frm_Owner.Txt_Address2.Value := ""
          Frm_Owner.Txt_StateName.Value := ""
          Frm_Owner.Txt_CityName.Value := ""
          Frm_Owner.Txt_ZipCode.Value := ""
          Frm_Owner.Txt_CodeArea.Value := ""
          Frm_Owner.Txt_PhoneOffice.Value := ""
          Frm_Owner.Txt_FiscalId.Value := ""
          Frm_Owner.Txt_Email.Value := ""
          Frm_Owner.Txt_CiaWEB.VALUE := ""
          Frm_Owner.Txt_Logo.Value := ""
          Frm_Owner.Txt_GlobalTaxPercen.Value := 0
          OwnerSwitchCia(1)
			ELSE
          GsIsNew := .F.                                       
          Frm_Owner.Txt_OwnerName.Value := aTableOwner[1,1]
          Frm_Owner.Txt_Address1.Value := aTableOwner[1,2]
          Frm_Owner.Txt_Address2.Value := aTableOwner[1,3]            
          GnMyStateId := C2SQL(aTableOwner[1,5])
          GnMyCityId := C2SQL(aTableOwner[1,6])
          Frm_Owner.Txt_ZipCode.Value := aTableOwner[1,7]
          Frm_Owner.Txt_CodeArea.Value := aTableOwner[1,8]
          Frm_Owner.Txt_PhoneOffice.Value := aTableOwner[1,9]
          Frm_Owner.Txt_FiscalId.Value := aTableOwner[1,10]
          Frm_Owner.Txt_Email.Value := aTableOwner[1,11]
          Frm_Owner.Txt_CiaWeb.VALUE := aTableOwner[1,12]
          Frm_Owner.Txt_Logo.Value := aTableOwner[1,13]
          Frm_Owner.Txt_StateName.Value := aTableOwner[1,14]             
          Frm_Owner.Txt_CityName.Value := aTableOwner[1,15]
          Frm_Owner.Txt_GlobalTaxPercen.Value := VAL(aTableOwner[1,16])  
          GsGlobalTaxPercen := VAL(aTableOwner[1,16]) 
				 OwnerSwitchCia(0)
			ENDIF

   RETURN

   PROCEDURE OwnerSwitchCia(Switch)
      DO CASE

// ********************** Por default. ************************************************************
         CASE Switch == 0
// Botones del formulario
            Frm_Owner.Btn_SeachStateOwner.Enabled  := .F.
            Frm_Owner.Btn_SearchCityOwner.Enabled  := .F.
            Frm_Owner.Btn_FindLogo.Enabled             := .F.

// Datos de captura
            Frm_Owner.Txt_OwnerName.Enabled     := .F.
            Frm_Owner.Txt_Address1.Enabled         := .F.
            Frm_Owner.Txt_Address2.Enabled         := .F.
            Frm_Owner.Txt_StateName.Enabled     := .F.
            Frm_Owner.Txt_CityName.Enabled         := .F.
            Frm_Owner.Txt_ZipCode.Enabled       := .F.
            Frm_Owner.Txt_CodeArea.Enabled         := .F.
            Frm_Owner.Txt_PhoneOffice.Enabled   := .F.
            Frm_Owner.Txt_FiscalId.Enabled         := .F.
            Frm_Owner.Txt_Email.Enabled         := .F.
            Frm_Owner.Txt_CiaWeb.ENABLED        := .F.
            Frm_Owner.Txt_Logo.ENABLED     := .F.
            Frm_Owner.Txt_GlobalTaxPercen.Enabled := .F.

// ********************** Edicin. ************************************************************
         CASE Switch == 1

// Botones del formulario
            Frm_Owner.Btn_SeachStateOwner.Enabled  := .T.
            Frm_Owner.Btn_SearchCityOwner.Enabled  := .T.
            Frm_Owner.Btn_FindLogo.Enabled             := .T.
// Datos de captura
            Frm_Owner.Txt_OwnerName.Enabled     := .T.
            Frm_Owner.Txt_Address1.Enabled         := .T.
            Frm_Owner.Txt_Address2.Enabled         := .T.
            Frm_Owner.Txt_StateName.Enabled     := .T.
            Frm_Owner.Txt_CityName.Enabled         := .T.
            Frm_Owner.Txt_ZipCode.Enabled       := .T.
            Frm_Owner.Txt_CodeArea.Enabled         := .T.
            Frm_Owner.Txt_PhoneOffice.Enabled   := .T.
            Frm_Owner.Txt_FiscalId.Enabled         := .T.
            Frm_Owner.Txt_Email.Enabled            := .T.
            Frm_Owner.Txt_CiaWeb.ENABLED           := .T.
            Frm_Owner.Txt_Logo.ENABLED     := .T.
            Frm_Owner.Txt_GlobalTaxPercen.Enabled := .T.
// Me posiciono en el boton de editar.
            Frm_Owner.Txt_OwnerName.SetFocus
      ENDCASE

   RETURN

   PROCEDURE ExitOwnerCia
      Frm_Owner.Release
   RETURN

   PROCEDURE SaveOwner
      LsProgName = "'" + PROCNAME() + "'"
      GdDateSQL := "DATE('NOW')"
      GsTimeSQL := "TIME('NOW','LOCALTIME')"
      LsOwnerName       := C2SQL( ALLTRIM (Frm_Owner.Txt_OwnerName.Value ))
      LsAddress1        := C2SQL( ALLTRIM (Frm_Owner.Txt_Address1.Value ))
      LsAddress2        := C2SQL( ALLTRIM (Frm_Owner.Txt_Address2.Value ))
      LsStateName       := C2SQL(  ALLTRIM (Frm_Owner.Txt_StateName.Value ))
      LsCityName        := C2SQL( ALLTRIM (Frm_Owner.Txt_CityName.Value ))
      LsZipCode         := C2SQL( ALLTRIM (Frm_Owner.Txt_ZipCode.Value ))
      LsCodeArea        := C2SQL( ALLTRIM (Frm_Owner.Txt_CodeArea.Value ))
      LsPhoneOffice     := C2SQL( ALLTRIM (Frm_Owner.Txt_PhoneOffice.Value ))
      LsFiscalId        := C2SQL( ALLTRIM (Frm_Owner.Txt_FiscalId.Value ))
      LsEmail           := C2SQL( ALLTRIM (Frm_Owner.Txt_Email.Value ))
      LsURL             := C2SQL( ALLTRIM (Frm_Owner.Txt_CiaWEB.VALUE))
      LsLogo            := C2SQL( ALLTRIM (Frm_Owner.Txt_Logo.Value))
      LsGlobalTaxPercen := C2SQL( Frm_Owner.Txt_GlobalTaxPercen.Value)
      LsProgName        := C2SQL( PROCNAME() )

		 IF GsIsNew
				 GsQuery := "INSERT INTO Owner ( "
				 GsQuery += "Id, "
				 GsQuery += "Name, "
				 GsQuery += "Address_1, "
				 GsQuery += "Address_2, "
				 GsQuery += "Country_Id, "
				 GsQuery += "State_Id, "
				 GsQuery += "City_Id, "
				 GsQuery += "Postal_Code, "
				 GsQuery += "Code_Area, "
				 GsQuery += "Phone_Office, "
				 GsQuery += "Fiscal_Id, "
				 GsQuery += "E_mail, "
				 GsQuery += "URL, "
				 GsQuery += "Logo_Owner, "
         GsQuery += "Global_Tax_Percen, "
				 GsQuery += "Prog_Name, "
				 GsQuery += "Sys_User_Id, "
				 GsQuery += "Entry_Date, "
				 GsQuery += "Entry_Time) "
				 GsQuery += "VALUES ("
				 GsQuery += C2SQL(1)+", "
				 GsQuery += C2SQL( ALLTRIM (Frm_Owner.Txt_OwnerName.Value ))+", "
				 GsQuery += C2SQL( ALLTRIM (Frm_Owner.Txt_Address1.Value ))+", "
				 GsQuery += C2SQL( ALLTRIM (Frm_Owner.Txt_Address2.Value ))+", "
				 GsQuery += C2SQL(GnCountryId)+", "
				 GsQuery += C2SQL(GnMyStateId)+", "
				 GsQuery += C2SQL(GnMyCityId)+", "
				 GsQuery += C2SQL( ALLTRIM (Frm_Owner.Txt_ZipCode.Value ))+", "
				 GsQuery += C2SQL( ALLTRIM (Frm_Owner.Txt_CodeArea.Value ))+", "
				 GsQuery += C2SQL( ALLTRIM (Frm_Owner.Txt_PhoneOffice.Value ))+", "
				 GsQuery += C2SQL( ALLTRIM (Frm_Owner.Txt_FiscalId.Value ))+", "
				 GsQuery += C2SQL( ALLTRIM (Frm_Owner.Txt_Email.Value ))+", "
				 GsQuery += C2SQL( ALLTRIM (Frm_Owner.Txt_CiaWEB.VALUE))+", "
				 GsQuery += C2SQL( ALLTRIM (Frm_Owner.Txt_Logo.Value))+", "
         GsQuery += C2SQL( Frm_Owner.Txt_GlobalTaxPercen.Value)+", "
				 GsQuery += "&GsSystemUser"+ ", "
				 GsQuery += GdDateSQL+", "
				 GsQuery += GsTimeSQL+", "
				 GsQuery += "&LsProgName )"
		 ELSE
				 GsQuery := "UPDATE Owner SET "
				 GsQuery += "Name = " + C2SQL( ALLTRIM (Frm_Owner.Txt_OwnerName.Value ))+ ", "
				 GsQuery += "Address_1 = "+C2SQL( ALLTRIM (Frm_Owner.Txt_Address1.Value ))+ ", "
				 GsQuery += "Address_2 = "+C2SQL( ALLTRIM (Frm_Owner.Txt_Address2.Value ))+ ", "
				 GsQuery += "Country_Id = "+C2SQL(GnCountryId)+ ", "
				 GsQuery += "State_Id = "+C2SQL(GnMyStateId)+ ", "
				 GsQuery += "City_Id = "+ C2SQL(GnMyCityId)+ ", "
				 GsQuery += "Postal_Code = "+C2SQL( ALLTRIM (Frm_Owner.Txt_ZipCode.Value ))+ ", "
				 GsQuery += "Code_Area = "+C2SQL( ALLTRIM (Frm_Owner.Txt_CodeArea.Value ))+ ", "
				 GsQuery += "Phone_Office ="+ C2SQL( ALLTRIM (Frm_Owner.Txt_PhoneOffice.Value ))+ ", "
				 GsQuery += "Fiscal_Id = "+C2SQL( ALLTRIM (Frm_Owner.Txt_FiscalId.Value ))+ ", "
				 GsQuery += "E_mail = "+C2SQL( ALLTRIM (Frm_Owner.Txt_Email.Value ))+ ", "
				 GsQuery += "URL = "+C2SQL( ALLTRIM (Frm_Owner.Txt_CiaWEB.VALUE))+ ", "
				 GsQuery += "Logo_Owner = "+C2SQL( ALLTRIM (Frm_Owner.Txt_Logo.Value))+ ", "
         GsQuery += "Global_Tax_Percen = "+C2SQL( Frm_Owner.Txt_GlobalTaxPercen.Value)+", " 
				 GsQuery += "Prog_Name = "+GsSystemUser+ ", "
				 GsQuery += "Modify_Date = " + GdDateSQL+ ", "
				 GsQuery += "Modify_Time = " + GsTimeSQL+ " "
				 GsQuery += "WHERE PS_Id = 1"
		 ENDIF
    IF TryToLock()
        IF BeforeSave(GsQuery)
          MsgInfo ( IIF (GsIsNew,"Registro insertado.","Registro actualizado")) 
          DeleteFileLock()
        ELSE
          MsgExclamation ("Error al tratar de insertar, actualizar.")
        ENDIF
    ENDIF 
     OwnerSwitchCia(0)
   RETURN

   PROCEDURE FindStateCia
      GsMyStateName := ""
      GnMyStateId := 0 
      GsMyCityName := ""
      GnMyCityId := 0
      Frm_Owner.Txt_StateName.Value := ""
      Frm_Owner.Txt_CityName.Value := ""
      ShowStates(55)
      GnMyStateId := GnData1      
      Frm_Owner.Txt_StateName.Value := GsData1 
      GsMyStateName := GsData1
      Frm_Owner.Btn_SearchCityOwner.SetFocus
   RETURN

   PROCEDURE FindCityCia
      GsMyCityName := ""
      GnMyCityId := 0
      Frm_Owner.Txt_CityName.Value := ""
      ShowCities(55,GnMyStateId)
      Frm_Owner.Txt_CityName.Value := GsData1
      GsMyCityName := GsData1
      GnMyCityId := GnData1
      Frm_Owner.Txt_ZipCode.SetFocus
   RETURN

   PROCEDURE FindDBOwner
      Frm_Owner.Txt_DBPathOwner.Value := Getfile ( { {"Posadas Software Data Base","Posoft.*"} } , "Seleccione la base de datos" , "C:\" , .F. , .T. )
   RETURN

    PROCEDURE FindLogo
        Frm_Owner.Txt_Logo.Value := Getfile ( { {"","*.*"} } , "Selecciona el LOGO de T empresa" , "C:\" , .F. , .T. )
    RETURN

RETURN

