﻿#INCLUDE <hmg.ch>
#INCLUDE "hbver.ch"
#INCLUDE <PS_Posoft.ch>

PROCEDURE Provider
   PRIVATE LnProviderId := LnStateId := LnCityId :=  0
   PRIVATE LsProviderName := LsCityName := LsStateName := ""
   PRIVATE aGetTableData:= {}
   PRIVATE GbIsNew := .T.
   LoadMyData()
   SET TOOLTIPSTYLE BALLOON
   IF IsWindowActive (Frm_Provider)
      MsgStop("Ya esta en en uso esta opción","ERROR")
      RETURN NIL
   ELSE
      LOAD WINDOW Frm_Provider
      END WINDOW
			IF .NOT. ConectMe()
			  RETURN
			ENDIF
      ProviderSwitch(0)
      CENTER WINDOW Frm_Provider
      ACTIVATE WINDOW Frm_Provider
   ENDIF

PROCEDURE ProviderSwitch(Switch)
   DO CASE
      CASE Switch == 0      // Todo apagado e inhibido
         Frm_Provider.Btn_New.Enabled        := .T.
         Frm_Provider.Btn_Edit.Enabled       := .F.
         Frm_Provider.Btn_Delete.Enabled     := .F.
         Frm_Provider.Btn_Back.Enabled       := .F.
         Frm_Provider.Btn_Save.Enabled       := .F.
         Frm_Provider.Btn_SeeDetail.Enabled  := .T.
         Frm_Provider.Btn_FillItUp.Enabled   := .T.
         Frm_Provider.Btn_Print.Enabled      := .F.
         Frm_Provider.Btn_Exit.Enabled       := .T.

         Frm_Provider.Btn_FindCity.Enabled         := .F.
         Frm_Provider.Btn_FindState.Enabled        := .F.
         Frm_Provider.Txt_FindIndividual.Visible   := .F.
         Frm_Provider.Fra_FindIndividualData.Visible   := .F.
         Frm_Provider.Btn_FindIndividual.Visible   := .F.

         Frm_Provider.Txt_ProviderName.Value       := ""
         Frm_Provider.Txt_Address1.Value           := ""
         Frm_Provider.Txt_Address2.Value           := ""
         Frm_Provider.Txt_StateName.Value          := ""
         Frm_Provider.Txt_CityName.Value           := ""
         Frm_Provider.Txt_ZipCode.Value            := ""
         Frm_Provider.Txt_CodeArea.Value           := ""
         Frm_Provider.Txt_PhoneOffice.Value        := ""
         Frm_Provider.Txt_FiscalId.Value           := ""
         Frm_Provider.Txt_DeliveryDay.Value       := 0
         Frm_Provider.Txt_CreditDay.Value          := 0
         Frm_Provider.Txt_ProviderName.Enabled     := .F.
         Frm_Provider.Txt_Address1.Enabled         := .F.
         Frm_Provider.Txt_Address2.Enabled         := .F.
         Frm_Provider.Txt_StateName.Enabled        := .F.
         Frm_Provider.Txt_CityName.Enabled         := .F.
         Frm_Provider.Txt_ZipCode.Enabled          := .F.
         Frm_Provider.Txt_CodeArea.Enabled         := .F.
         Frm_Provider.Txt_PhoneOffice.Enabled      := .F.
         Frm_Provider.Txt_FiscalId.Enabled         := .F.
         Frm_Provider.Txt_AgentName.Enabled       := .F.
         Frm_Provider.Txt_AgentEMail.Enabled      := .F.
         Frm_Provider.Txt_AgentMovil.Enabled      := .F.
         Frm_Provider.Txt_DeliveryDay.Enabled    := .F.
         Frm_Provider.Txt_CreditDay.Enabled       := .F.

      CASE Switch == 1      // New después de verificar "IfExistsProvider"
         Frm_Provider.Btn_New.Enabled           := .F.
         Frm_Provider.Btn_Edit.Enabled          := .F.
         Frm_Provider.Btn_Delete.Enabled        := .F.
         Frm_Provider.Btn_Exit.Enabled          := .F.
         Frm_Provider.Btn_Print.Enabled         := .F.
         Frm_Provider.Btn_SeeDetail.Enabled     := .F.
         Frm_Provider.Btn_Save.Enabled          := .T.
         Frm_Provider.Btn_Back.Enabled          := .T.
         Frm_Provider.Btn_FillItUp.Enabled      := .F.
         Frm_Provider.Btn_FindState.Enabled     := .T.
         Frm_Provider.Btn_FindCity.Enabled      := .T.

         Frm_Provider.Txt_ProviderName.Enabled  := .T.
         Frm_Provider.Txt_Address1.Enabled      := .T.
         Frm_Provider.Txt_address2.Enabled      := .T.
         Frm_Provider.Txt_StateName.Enabled     := .T.
         Frm_Provider.Txt_CityName.Enabled      := .T.
         Frm_Provider.Txt_ZipCode.Enabled       := .T.
         Frm_Provider.Txt_CodeArea.Enabled      := .T.
         Frm_Provider.Txt_PhoneOffice.Enabled   := .T.
         Frm_Provider.Txt_FiscalId.Enabled      := .T.
         Frm_Provider.Txt_AgentName.Enabled       := .T.
         Frm_Provider.Txt_AgentEMail.Enabled      := .T.
         Frm_Provider.Txt_AgentMovil.Enabled      := .T.
         Frm_Provider.txt_DeliveryDay.Enabled  := .T.
         Frm_Provider.Txt_CreditDay.Enabled     := .T.

      CASE Switch == 2      // Desiste de la captura
         Frm_Provider.Btn_New.Enabled        := .F.
         Frm_Provider.Btn_Edit.Enabled       := .F.
         Frm_Provider.Btn_Delete.Enabled     := .F.
         Frm_Provider.Btn_Back.Enabled       := .T.
         Frm_Provider.Btn_Save.Enabled       := .F.
         Frm_Provider.Btn_SeeDetail.Enabled  := .F.
         Frm_Provider.Btn_FillItUp.Enabled   := .F.
         Frm_Provider.Btn_Print.Enabled      := .F.
         Frm_Provider.Btn_Exit.Enabled       := .F.

      CASE Switch == 3      // Consulta por codigo cliente.
         Frm_Provider.Btn_New.Enabled        := .F.
         Frm_Provider.Btn_Edit.Enabled       := .F.
         Frm_Provider.Btn_Delete.Enabled     := .F.
         Frm_Provider.Btn_Exit.Enabled       := .F.
         Frm_Provider.Btn_Print.Enabled      := .F.
         Frm_Provider.Btn_SeeDetail.Enabled  := .F.
         Frm_Provider.Btn_Save.Enabled       := .T.
         Frm_Provider.Btn_Back.Enabled       := .T.
         Frm_Provider.Btn_FillItUp.Enabled   := .F.

      CASE Switch = 10     // Limpia los campos a captura
         GbIsNew := .T.
         Frm_Provider.Btn_New.Enabled        := .F.
         Frm_Provider.Btn_Edit.Enabled       := .F.
         Frm_Provider.Btn_Delete.Enabled     := .F.
         Frm_Provider.Btn_Back.Enabled       := .T.
         Frm_Provider.Btn_Save.Enabled       := .T.
         Frm_Provider.Btn_SeeDetail.Enabled  := .F.
         Frm_Provider.Btn_FillItUp.Enabled   := .F.
         Frm_Provider.Btn_Print.Enabled      := .F.
         Frm_Provider.Btn_Exit.Enabled       := .F.

         Frm_Provider.Txt_FindIndividual.Visible   := .F.
         Frm_Provider.Fra_FindIndividualData.Visible   := .F.

         Frm_Provider.Txt_ProviderName.Value := ""
         Frm_Provider.Txt_Address1.Value := ""
         Frm_Provider.Txt_Address2.Value := ""
         Frm_Provider.Txt_StateName.Value := ""
         Frm_Provider.Txt_CityName.Value := ""
         Frm_Provider.Txt_ZipCode.Value := ""
         Frm_Provider.Txt_CodeArea.Value := ""
         Frm_Provider.Txt_PhoneOffice.Value := ""
         Frm_Provider.Txt_FiscalId.Value := ""
         Frm_Provider.Txt_AgentName.Value := ""
         Frm_Provider.Txt_AgentEMail.Value := ""
         Frm_Provider.Txt_AgentMovil.Value := ""
         Frm_Provider.Txt_DeliveryDay.Value := 0
         Frm_Provider.Txt_CreditDay.Value := 0

         Frm_Provider.Btn_FindState.Enabled     := .T.
         Frm_Provider.Btn_FindCity.Enabled      := .T.

         Frm_Provider.Txt_ProviderName.Enabled  := .T.
         Frm_Provider.Txt_Address1.Enabled      := .T.
         Frm_Provider.Txt_address2.Enabled      := .T.
         Frm_Provider.Txt_StateName.Enabled     := .T.
         Frm_Provider.Txt_CityName.Enabled      := .T.
         Frm_Provider.Txt_ZipCode.Enabled       := .T.
         Frm_Provider.Txt_CodeArea.Enabled      := .T.
         Frm_Provider.Txt_PhoneOffice.Enabled   := .T.
         Frm_Provider.Txt_FiscalId.Enabled      := .T.
         Frm_Provider.Txt_ZipCode.Enabled       := .T.
         Frm_Provider.Txt_AgentName.Enabled     := .T.
         Frm_Provider.Txt_AgentEMail.Enabled    := .T.
         Frm_Provider.Txt_AgentMovil.Enabled    := .T.
         Frm_Provider.Txt_DeliveryDay.Enabled  := .T.
         Frm_Provider.Txt_CreditDay.Enabled     := .T.

         Frm_Provider.Txt_ProviderName.SetFocus

   ENDCASE
RETURN

PROCEDURE NewProviderData
   GbIsNew := .T.
   ProviderSwitch(10)
RETURN

PROCEDURE ModifyProvider
  IF Frm_Provider.Grd_Provider.Value = 0
    MsgInfo("Selecciona un proveedor.")
    Frm_Provider.Grd_Provider.Value := 1
    Frm_Provider.Grd_Provider.SetFocus
    RETURN
  ELSE
   GetProviderData()
   LsProviderId := ColumnGridValue( "Grd_Provider", "Frm_Provider", 1)
   GbIsNew := .F.
   ProviderSwitch(1)
   Frm_Provider.Txt_ProviderName.SetFocus
  ENDIF
RETURN

PROCEDURE GetProviderData
  LnProviderId                           := VAL(ColumnGridValue( "Grd_Provider", "Frm_Provider", 1 ))
  Frm_Provider.Txt_ProviderName.Value    := ColumnGridValue( "Grd_Provider", "Frm_Provider", 2 )
  Frm_Provider.Txt_Address1.Value        := ColumnGridValue( "Grd_Provider", "Frm_Provider", 3 )
  Frm_Provider.Txt_Address2.Value        := ColumnGridValue( "Grd_Provider", "Frm_Provider", 4 )
  LnStateId                              := VAL(ColumnGridValue( "Grd_Provider", "Frm_Provider",5 ))
  LnCityId                               := VAL(ColumnGridValue( "Grd_Provider", "Frm_Provider",6 ))
  Frm_Provider.Txt_ZipCode.Value         := ColumnGridValue( "Grd_Provider", "Frm_Provider", 7 )
  Frm_Provider.Txt_CodeArea.Value        := ColumnGridValue( "Grd_Provider", "Frm_Provider", 8 )
  Frm_Provider.Txt_PhoneOffice.Value     := ColumnGridValue( "Grd_Provider", "Frm_Provider", 9 )
  Frm_Provider.Txt_FiscalId.Value        := ColumnGridValue( "Grd_Provider", "Frm_Provider", 10 )
  Frm_Provider.Txt_StateName.Value       := ColumnGridValue( "Grd_Provider", "Frm_Provider", 11 )
  Frm_Provider.Txt_CityName.Value        := ColumnGridValue( "Grd_Provider", "Frm_Provider", 12 )
  Frm_Provider.Txt_AgentName.Value       := ColumnGridValue( "Grd_Provider", "Frm_Provider", 13 )
  Frm_Provider.Txt_AgentEMail.Value      := ColumnGridValue( "Grd_Provider", "Frm_Provider", 14 )
  Frm_Provider.Txt_AgentMovil.Value      := ColumnGridValue( "Grd_Provider", "Frm_Provider", 15 )
  Frm_Provider.Txt_DeliveryDay.Value    := VAL(ColumnGridValue( "Grd_Provider", "Frm_Provider", 16 ))
  Frm_Provider.Txt_CreditDay.Value        := VAL(ColumnGridValue("Grd_Provider","Frm_Provider",17))
RETURN

PROCEDURE GetDataProviders
	Frm_Provider.Grd_Provider.DeleteAllItems
   GsReadQuery :="SELECT "
   GsReadQuery += "p.Provider_Id, "
   GsReadQuery += "p.Name, "
   GsReadQuery += "p.Address_1, "
   GsReadQuery += "p.Address_2, "
   GsReadQuery += "p.State_Id, "
   GsReadQuery += "p.City_Id, "
   GsReadQuery += "p.Postal_Code, "
   GsReadQuery += "p.Code_Area, "
   GsReadQuery += "p.Phone_Office, "
   GsReadQuery += "p.Fiscal_Id, "
   GsReadQuery += "IFNULL(s.Name,'') AS State_Name, "
   GsReadQuery += "IFNULL(c.Name,'') AS City_Name, "
   GsReadQuery += "p.Agent_Name, "
   GsReadQuery += "p.Agent_EMail, "
   GsReadQuery += "p.Agent_Movil, "
   GsReadQuery += "p.Delivery_Day, "
   GsReadQuery += "p.Credit_Day "
   GsReadQuery += "FROM Provider AS p "
   GsReadQuery += "LEFT JOIN STATES AS s ON s.State_Id = p.State_Id "
   GsReadQuery += "LEFT JOIN CITIES AS c ON c.City_Id = p.City_Id "
   GsReadQuery += " WHERE p.IS_VISIBLE = 1 "
   GsReadQuery += "ORDER BY p.Name"
   IF TryToLock()
    aGetTableData := ReadData (GsReadQuery)
    DeleteFileLock()
   ENDIF

	IF LEN (aGetTableData) > 0
	 FillItUpProvider(aGetTableData)
	ELSE
	 MsgExclamation ( "No existe ningún proveedor en la base de datos." )
	ENDIF
RETURN(aGetTableData)

PROCEDURE IfExistsProvider
  IF GbIsNew
   GsReadQuery :="SELECT "
   GsReadQuery += "p.Provider_Id, "
   GsReadQuery += "p.Name, "
   GsReadQuery += "p.Address_1, "
   GsReadQuery += "p.Address_2, "
   GsReadQuery += "p.State_Id, "
   GsReadQuery += "p.City_Id, "
   GsReadQuery += "p.Postal_Code, "
   GsReadQuery += "p.Code_Area, "
   GsReadQuery += "p.Phone_Office, "
   GsReadQuery += "p.Fiscal_Id, "
   GsReadQuery += "IFNULL(s.Name,'') AS State_Name, "
   GsReadQuery += "IFNULL(c.Name,'') AS City_Name, "
   GsReadQuery += "p.Agent_Name, "
   GsReadQuery += "p.Agent_EMail, "
   GsReadQuery += "p.Agent_Movil, "
   GsReadQuery += "p.Delivery_Day, "
   GsReadQuery += "p.Credit_Day "
   GsReadQuery += "FROM Provider AS p "
   GsReadQuery += "LEFT JOIN STATES AS s ON s.State_Id = p.State_Id "
   GsReadQuery += "LEFT JOIN CITIES AS c ON c.City_Id = p.City_Id "
    GsReadQuery += "WHERE p.Name = "+C2SQL(ALLTRIM(Frm_Provider.Txt_ProviderName.Value))
    GsReadQuery += " AND p.IS_VISIBLE = 1 "

		 IF TryToLock()
			 aGetTableData := ReadData (GsReadQuery)
			 DeleteFileLock()
		 ENDIF

		 IF LEN (aGetTableData) > 0
			 LnProviderId                             := aGetTableData[1,1]
			 Frm_Provider.Txt_ProviderName.Value      := aGetTableData[1,2]
			 Frm_Provider.Txt_Address1.Value          := aGetTableData[1,3]
			 Frm_Provider.Txt_Address2.Value          := aGetTableData[1,4]
			 LnStateId                                := aGetTableData[1,5]
			 LnCityId                                 := aGetTableData[1,6]
			 Frm_Provider.Txt_ZipCode.Value           := aGetTableData[1,7]
			 Frm_Provider.Txt_CodeArea.Value          := aGetTableData[1,8]
			 Frm_Provider.Txt_PhoneOffice.Value       := aGetTableData[1,9]
         Frm_Provider.Txt_FiscalId.Value          := aGetTableData[1,10]
			 Frm_Provider.Txt_StateName.Value         := aGetTableData[1,11]
			 Frm_Provider.Txt_CityName.Value          := aGetTableData[1,12]
         Frm_Provider.Txt_AgentName.Value         := aGetTableData[1,13]
			 Frm_Provider.Txt_AgentEMail.Value        := aGetTableData[1,14]
			 Frm_Provider.Txt_AgentMovil.Value        := aGetTableData[1,15]
          Frm_Provider.Txt_DeliveryDay.Value      := aGetTableData[1,16]
          Frm_Provider.Txt_CreditDay.Value      := aGetTableData[1,17]
		 ELSE
			 Frm_Provider.Txt_Address1.Value          := ""
			 Frm_Provider.Txt_Address2.Value          := ""
			 LnStateId                                := 0
			 LnCityId                                 := 0
			 Frm_Provider.Txt_ZipCode.Value           := ""
			 Frm_Provider.Txt_CodeArea.Value          := ""
			 Frm_Provider.Txt_PhoneOffice.Value       := ""
			 Frm_Provider.Txt_FiscalId.Value          := ""
			 Frm_Provider.Txt_StateName.Value         := ""
			 Frm_Provider.Txt_CityName.Value          := ""
         Frm_Provider.Txt_DeliveryDay.Value       := 0
         Frm_Provider.Txt_CreditDay.Value          := 0
		 ENDIF
  ENDIF
RETURN

PROCEDURE FillItUpProvider
	Frm_Provider.Grd_Provider.DeleteAllItems
  FOR i := 1 TO LEN (aGetTableData)
			Frm_Provider.Grd_Provider.AddItem ( {  ALLTRIM(STR(aGetTableData[i,1])), +;
			aGetTableData[i,2], +;
			aGetTableData[i,3], +;
			aGetTableData[i,4], +;
			STR(aGetTableData[i,5]), +;
			STR(aGetTableData[i,6]), +;
			aGetTableData[i,7], +;
			aGetTableData[i,8], +;
			aGetTableData[i,9], +;
			aGetTableData[i,10], +;
			aGetTableData[i,11], +;
			aGetTableData[i,12], +;
			aGetTableData[i,13], +;
			aGetTableData[i,14], +;
         aGetTableData[i,15], +;
         STR(aGetTableData[i,16]), +;
         STR(aGetTableData[i,17]) })
	NEXT i

	IF Frm_Provider.Grd_Provider.ItemCount > 0
		Frm_Provider.Btn_Edit.Enabled := .T.
		Frm_Provider.Btn_Delete.Enabled := .T.
		Frm_Provider.Btn_Print.Enabled := .T.
	ELSE
		Frm_Provider.Btn_Edit.Enabled := .F.
		Frm_Provider.Btn_Delete.Enabled := .F.
		Frm_Provider.Btn_Print.Enabled := .F.
	ENDIF
RETURN

PROCEDURE SaveProvider
   GdDateSQL := "DATE('NOW')"
   GsTimeSQL := "TIME('NOW','LOCALTIME')"
   IF CheckBeforeSaveProvider()
    IF TryToLock()
      IF GbIsNew
// Inserta o actualiza el registro.
		  GsQuery := "INSERT INTO Provider ("
        GsQuery += "Provider_Id, "
        GsQuery += "Name, "
        GsQuery += "Address_1, "
        GsQuery += "Address_2, "
        GsQuery += "State_Id, "
        GsQuery += "City_Id, "
        GsQuery += "Postal_Code, "
        GsQuery += "Code_Area, "
        GsQuery += "Phone_Office, "
        GsQuery += "Fiscal_Id, "
        GsQuery += "Agent_Name, "
        GsQuery += "Agent_EMail, "
        GsQuery += "Agent_Movil, "
        GsQuery += "Delivery_Day, "
        GsQuery += "Credit_Day, "
        GsQuery += "Is_Visible, "
        GsQuery += "Prog_Name, "
        GsQuery += "Entry_Date, "
        GsQuery += "Entry_Time) VALUES ("
        GsQuery += C2SQL(GetNextNumber("Provider_id")) + ","
        GsQuery += C2SQL(Frm_Provider.Txt_ProviderName.Value) + ","
        GsQuery += C2SQL(Frm_Provider.Txt_Address1.Value) + ","
        GsQuery += C2SQL(Frm_Provider.Txt_Address2.Value) + ","
        GsQuery += C2SQL(LnStateId) + ","
        GsQuery += C2SQL(LnCityId) + ","
        GsQuery += C2SQL(Frm_Provider.Txt_ZipCode.Value) + ","
        GsQuery += C2SQL(Frm_Provider.Txt_CodeArea.Value) + ","
        GsQuery += C2SQL(Frm_Provider.Txt_PhoneOffice.Value) + ","
        GsQuery += C2SQL(Frm_Provider.Txt_FiscalId.Value) + ","
        GsQuery += C2SQL(Frm_Provider.Txt_AgentName.Value) + ","
        GsQuery += C2SQL(Frm_Provider.Txt_AgentEMail.Value) + ","
        GsQuery += C2SQL(Frm_Provider.Txt_AgentMovil.Value) + ","
        GsQuery += C2SQL(Frm_Provider.Txt_DeliveryDay.Value) + ","
        GsQuery += C2SQL(Frm_Provider.Txt_CreditDay.Value) + ","
        GsQuery += C2SQL(1) + ", "
        GsQuery += C2SQL(PROCNAME()) + ","
        GsQuery += GdDateSQL+", "
        GsQuery += GsTimeSQL +")"
  		ELSE
        GsQuery := "UPDATE Provider SET "
        GsQuery += "Provider_Id = " + C2SQL(LnProviderId) + ","
        GsQuery += "Name = " + C2SQL(Frm_Provider.Txt_ProviderName.Value) + ","
        GsQuery += "Address_1 = " + C2SQL(Frm_Provider.Txt_Address1.Value) + ","
        GsQuery += "Address_2 = " + C2SQL(Frm_Provider.Txt_Address2.Value) + ","
        GsQuery += "State_id = " + C2SQL(LnStateId) + ","
        GsQuery += "City_Id = " + C2SQL(LnCityId) + ","
        GsQuery += "Postal_Code = " + C2SQL(Frm_Provider.Txt_ZipCode.Value) + ","
        GsQuery += "Code_Area = " + C2SQL(Frm_Provider.Txt_CodeArea.Value) + ","
        GsQuery += "Phone_Office = " + C2SQL(Frm_Provider.Txt_PhoneOffice.Value) + ","
        GsQuery += "Fiscal_Id = " + C2SQL(Frm_Provider.Txt_FiscalId.Value) + ","
        GsQuery += "Agent_Name = " + C2SQL(Frm_Provider.Txt_AgentName.Value) + ","
        GsQuery += "Agent_EMail = " + C2SQL(Frm_Provider.Txt_AgentEMail.Value) + ","
        GsQuery += "Agent_Movil = " + C2SQL(Frm_Provider.Txt_AgentMovil.Value) + ","
        GsQuery += "Delivery_Day = " + C2SQL(Frm_Provider.Txt_DeliveryDay.Value) + ","
        GsQuery += "Credit_Day = " + C2SQL(Frm_Provider.Txt_CreditDay.Value) + ","
        GsQuery += "Prog_Name = " + C2SQL(PROCNAME()) + ","
        GsQuery += "Modify_Date = " + GdDateSQL +", "
        GsQuery += "Modify_Time = " + GsTimeSQL
        GsQuery += "WHERE Provider_Id = " + C2SQL(LnProviderId)
  		ENDIF
        IF BeforeSave(GsQuery)
          MsgInfo ( IIF (GbIsNew,"Registro insertado o actualizado.","Registro actualizado"+HB_OSNewLine()+"Cargue de nuevo los datos."))
          DeleteFileLock()
        ELSE
         MsgExclamation ("Error al tratar de insertar, actualizar.")
        ENDIF
      ELSE
        RETURN
      ENDIF
      ProviderSwitch(0)
  ENDIF
 RETURN

PROCEDURE ExistsProvider
   GsReadQuery :="SELECT "
   GsReadQuery += "p.Provider_Id, "
   GsReadQuery += "p.Name, "
   GsReadQuery += "p.Address_1, "
   GsReadQuery += "p.Address_2, "
   GsReadQuery += "p.State_Id, "
   GsReadQuery += "p.City_Id, "
   GsReadQuery += "p.Postal_Code, "
   GsReadQuery += "p.Code_Area, "
   GsReadQuery += "p.Phone_Office, "
   GsReadQuery += "p.Fiscal_Id, "
   GsReadQuery += "IFNULL(s.Name,'') AS State_Name, "
   GsReadQuery += "IFNULL(c.Name,'') AS City_Name, "
   GsReadQuery += "p.Agent_Name, "
   GsReadQuery += "p.Agent_EMail, "
   GsReadQuery += "p.Agent_Movil, "
   GsReadQuery += "p.Delivery_Days, "
   GsReadQuery += "p.Credit_Day, "
   GsReadQuery += "FROM Provider AS p "
   GsReadQuery += "LEFT JOIN STATES AS s ON s.State_Id = p.State_Id "
   GsReadQuery += "LEFT JOIN CITIES AS c ON c.City_Id = p.City_Id "
   GsReadQuery += "WHERE p.Provider_Id = " + C2SQL(LnProviderId)

  IF TryToLock()
   aGetTableData := ReadData (GsReadQuery)
   DeleteFileLock()
  ENDIF

   IF LEN (aGetTableData) > 0
      GbIsNew := .F.
      FOR i := 1 TO LEN (aGetTableData)
        LnProviderId                            := aGetTableData[i,1]
        Frm_Provider.Txt_ProviderName.Value     := aGetTableData[i,2]
        Frm_Provider.Txt_Address1.Value         := aGetTableData[i,3]
        Frm_Provider.Txt_Address2.Value         := aGetTableData[i,4]
        LnStateId                               := STR(aGetTableData[i,5])
        LnCityId                                := STR(aGetTableData[i,6])
        Frm_Provider.Txt_ZipCode.Value          := aGetTableData[i,7]
        Frm_Provider.Txt_CodeArea.Value         := aGetTableData[i,8]
        Frm_Provider.Txt_PhoneOffice.Value      := aGetTableData[i,9]
        Frm_Provider.Txt_FiscalId.Value         := aGetTableData[i,10]
        Frm_Provider.Txt_StateName.Value        := aGetTableData[i,11]
        Frm_Provider.Txt_CityName.Value         := aGetTableData[i,12]
        Frm_Provider.Txt_AgentName.Value         := aGetTableData[1,13]
         Frm_Provider.Txt_AgentEMail.Value        := aGetTableData[1,14]
         Frm_Provider.Txt_AgentMovil.Value        := aGetTableData[1,15]
         Frm_Provider.Txt_DeliveryDay.Value  := VAL(aGetTableData[1,16])
         Frm_Provider.Txt_CreditDay.Value  := VAL(aGetTableData[1,17])
      NEXT i
   ELSE
      GbIsNew := .T.
   ENDIF
//  ENDIF
RETURN

PROCEDURE UndoProvider
   ProviderSwitch(0)
RETURN

PROCEDURE DropProvider
   LOCAL LnGridRow
   LsProviderId := VAL(ColumnGridValue( "Grd_Provider", "Frm_Provider", 1))
   LnGridRow := Frm_Provider.Grd_Provider.Value
   GsReadQuery := "SELECT PS_Id, Provider_Id, Name FROM Provider "
   GsReadQuery += "WHERE Provider_Id = " + C2SQL(LnProviderId)
  IF TryToLock()
      aGetTableData := ReadData (GsReadQuery)
      DeleteFileLock()
  ENDIF

	IF LEN (aGetTableData) > 0
		  Frm_Provider.Txt_ProviderName.Value := aGetTableData[1,3]
		IF MsgYesNo("¿Desea eliminar este proveedor?:"+HB_OSNewLine()+ Frm_Provider.Txt_ProviderName.Value,"¡Borrar!")
		  GsQueryDelete :="DELETE FROM Provider WHERE Provider_Id = " + C2SQL(LnProviderId)
		  IF TryToLock()
				IF BeforeSave(GsQueryDelete)
				  MsgInfo ( "Registro ha sido eliminado."+HB_OSNewLine()+"Cargue de nuevo los datos.")
				  DeleteFileLock()
				ELSE
				  MsgExclamation ("Error al tratar de borrar el proveedor")
				ENDIF
			ENDIF
		ENDIF
	ENDIF

 RETURN

PROCEDURE EditProvider
   ProviderSwitch(2)
RETURN

PROCEDURE FindOneProvider
   Frm_Provider.Btn_Back.Enabled := .T.
   Frm_Provider.Btn_Exit.Enabled := .F.
   Frm_Provider.Btn_SeeDetail.Enabled := .T.
   Frm_Provider.Btn_New.Enabled := .F.
   Frm_Provider.Btn_FillItUp.Enabled := .F.
   Frm_Provider.Txt_FindIndividual.Visible   := .T.
   Frm_Provider.Fra_FindIndividualData.Visible   := .T.
   Frm_Provider.Btn_FindIndividual.Visible   := .T.
   Frm_Provider.Txt_FindIndividual.Value := ""
   Frm_Provider.Txt_FindIndividual.SetFocus
RETURN

PROCEDURE FindIndividualProvider
   Frm_Provider.Btn_New.Enabled := .F.
   Frm_Provider.Btn_FillItUp.Enabled := .F.
   Frm_Provider.Btn_Delete.Enabled := .T.
   Frm_Provider.Btn_Edit.Enabled := .T.
   Frm_Provider.Btn_Back.Enabled := .T.
   Frm_Provider.Btn_SeeDetail.Enabled := .T.
   Frm_Provider.Btn_Print.Enabled := .T.
   Frm_Provider.Fra_FindIndividualData.Visible := .T.
   Frm_Provider.Txt_FindIndividual.Visible := .T.
   LsToSearch := ALLTRIM ( Frm_Provider.Txt_FindIndividual.Value )
   GsReadQuery :="SELECT "
   GsReadQuery += "p.Provider_Id, "
   GsReadQuery += "p.Name, "
   GsReadQuery += "p.Address_1, "
   GsReadQuery += "p.Address_2, "
   GsReadQuery += "p.State_Id, "
   GsReadQuery += "p.City_Id, "
   GsReadQuery += "p.Postal_Code, "
   GsReadQuery += "p.Code_Area, "
   GsReadQuery += "p.Phone_Office, "
   GsReadQuery += "p.Fiscal_Id, "
   GsReadQuery += "IFNULL(s.Name,'') AS State_Name, "
   GsReadQuery += "IFNULL(c.Name,'') AS City_Name, "
   GsReadQuery += "p.Agent_Name, "
   GsReadQuery += "p.Agent_EMail, "
   GsReadQuery += "p.Agent_Movil, "
   GsReadQuery += "p.Delivery_Day, "
   GsReadQuery += "p.Credit_Day "
   GsReadQuery += "FROM Provider AS p "
   GsReadQuery += "LEFT JOIN STATES AS s ON s.State_Id = p.State_Id "
   GsReadQuery += "LEFT JOIN CITIES AS c ON c.City_Id = p.City_Id "
   GsReadQuery += "WHERE p.Is_Visible = 1 "
   GsReadQuery += "AND p.Name LIKE '%" + LsToSearch + "%' "
   IF TryToLock()
			aGetTableData := ReadData (GsReadQuery)
			DeleteFileLock()
   ENDIF
	 IF LEN (aGetTableData) = 0
			MsgExclamation ( "No se encontro ningun dato similiar al deseado." )
			Frm_Provider.Txt_FindIndividual.SetFocus
			RETURN
	 ELSE
      FillItUpProvider(aGetTableData)
   ENDIF
RETURN

PROCEDURE PrintProviderData
RETURN

PROCEDURE ExitProvider
   Frm_Provider.Release
RETURN

PROCEDURE FindProviderState
   LnStateId := LnCityId := 0
   LsStateName := LsCityName := ""
   Frm_Provider.Txt_StateName.Value := ""
   Frm_Provider.Txt_CityName.Value := ""
   ShowStates(55)
   LnStateId := GnData1
   LsStateName := GsData1
   Frm_Provider.Txt_StateName.Value := LsStateName
   Frm_Provider.Btn_FindCity.SetFocus
RETURN

PROCEDURE FindProviderCity
   LsCityName := ""
   LnCityId := 0
   Frm_Provider.Txt_CityName.Value := ""
   ShowCities(55, LnStateId)
   LnCityId := GnData1
   LsCityName := GsData1
   Frm_Provider.Txt_CityName.Value := LsCityName
   Frm_Provider.Txt_ZipCode.SetFocus
RETURN

FUNCTION CheckBeforeSaveProvider
  LOCAL LbReturn := .T.

    IF EMPTY (Frm_Provider.Txt_ProviderName.Value)
      MsgExclamation ( "Ingresa el nombre del proveedor" , "¡Error!" )
      Frm_Provider.Txt_ProviderName.SetFocus
      RETURN(.F.)
    ENDIF

    IF EMPTY (Frm_Provider.Txt_StateName.Value) .OR. EMPTY ( Frm_Provider.Txt_CityName.Value )
      MsgExclamation ( "Selecciona el estado y/o ciudad." , "¡Error!" )
      Frm_Provider.Btn_FindState.SetFocus
      RETURN(.F.)
    ENDIF

    IF .NOT. EMPTY(Frm_Provider.Txt_ProviderName.Value)
      GsReadQuery := "SELECT Name FROM Provider WHERE "
      GsReadQuery += "Name = "
      GsReadQuery += C2SQL(ALLTRIM(Frm_Provider.Txt_ProviderName.Value))
      IF TryToLock()
        aCheckData := ReadData(GsReadQuery)
        DeleteFileLock()
      ENDIF

      IF LEN(aCheckData) > 0 .AND. GbIsNew
        MsgExclamation("Ya existe ese nombre de proveedor en la base de datos,"+HB_OSNewLine()+;
        "teclea uno valido.","¡Error!")
        Frm_Provider.Txt_ProviderName.SetFocus
        RETURN(.F.)
      ENDIF
    ENDIF

RETURN ( LbReturn )

RETURN
