﻿#INCLUDE <hmg.ch>
#INCLUDE "hbver.ch"
#INCLUDE <PS_Posoft.ch>

PROCEDURE PrintPurchaseOrderReport(PsQuery, PsPOStatus)
   LOCAL LbSuccess := .f.
	LsQuery := PsQuery       
   LsPOStatus := PsPOStatus     
   LnPOCounter := LnPOTotalAmount := 0
	IF ConectMe() 
		IF TryToLock()
			aPurchaseReport := sql(oDataBase,LsQuery)
			DeleteFileLock()
		ELSE
		   RETURN
		ENDIF 
	ENDIF              
  
// Imprime el reporte 
                         
  GnPageNum := 0
  LnLine2Print := 84     
  DocumentName := GsRutaRPT+"Purchase_Report_"+ALLTRIM(STR(aPurchaseReport[1,1]))
  PutMsg("Espere... buscando registro para su impresión")
  SELECT PRINTER DIALOG  TO LbSuccess PREVIEW
  PAPERSIZE PRINTER_PAPER_LETTER
  
	IF LbSuccess
		PutMsg("Espere... preparando datos para impresión")
		START PRINTDOC  
		START PRINTPAGE
		FOR d := 1 TO LEN (aPurchaseReport)
			IF GnPageNum = 0 .OR. LnLine2Print >= 252
        PrintHeader(0002)   
        @ 19, 110 PRINT LsPOStatus CENTER SIZE 7 BOLD  
        LnLine2Print := 34 
			ENDIF
         LnPOCounter += 1
         LnPOTotalAmount += VAL(aPurchaseReport[d,10])      
         LdPOPay := CTOD(aPurchaseReport[d,6]) + aPurchaseReport[d,16] 
         @ LnLine2Print, 17 PRINT aPurchaseReport[d,1] SIZE 6
         @ LnLine2Print, 30 PRINT aPurchaseReport[d,3] SIZE 6
//         @ LnLine2Print, 100 PRINT aPurchaseReport[d,6] SIZE 6 
         @ LnLine2Print, 100 PRINT WichDate("DMAS",CTOD(aPurchaseReport[d,6])) SIZE 6 
         @ LnLine2Print, 135 PRINT aPurchaseReport[d,16] SIZE 6
         @ LnLine2Print, 160 PRINT WichDate("DMAS",LdPOPay) SIZE 6
         @ LnLine2Print, 185 PRINT TRANSFORM(VAL(aPurchaseReport[d,10]),"$999,999,999.99") SIZE 6
         LnLine2Print += 3
      NEXT d 
      LnLine2Print += 6 
      @ LnLine2Print,10 PRINT LINE TO LnLine2Print, 205 PENWIDTH  .5    
       @ LnLine2Print+4, 25 PRINT ALLTRIM(STR(LnPOCounter)) SIZE 6     
       @ LnLine2Print+4, 40 PRINT TRANSFORM(LnPOTotalAmount,"$999,999,999,999.99") SIZE 6 
      END PRINTPAGE                                                                             
      END PRINTDOC         
      ClearMsg()
	ENDIF
RETURN 