#INCLUDE <hmg.ch>
#INCLUDE <PS_Posoft.ch>

PROCEDURE ShowCities (PnCountryId, PnStateId)
  PRIVATE LnCountryId, LnStateId 
  LnCountryId := PnCountryId
  LnStateId := PnStateId                                                              
   SET TOOLTIPSTYLE BALLOON
   IF IsWindowActive (Frm_ShowCities)
      MsgStop("Ya esta en en uso esta opcin","ERROR")
      RETURN NIL
   ELSE
      LOAD WINDOW Frm_ShowCities
      END WINDOW
      GetAllCities()
      FillGridCities()
      CENTER WINDOW Frm_ShowCities 
      ACTIVATE WINDOW Frm_ShowCities 
   ENDIF 
 
   PROCEDURE GetAllCities
      GsReadQuery := "SELECT Name, City_Id FROM Cities "
      GsReadQuery += "WHERE State_Id = "+C2SQL(LnStateId)
      GsReadQuery += " AND Country_id = "+C2SQL(LnCountryId)
      GsReadQuery += " AND Is_Visible > 0 ORDER BY Name"
      FillGridCities()
   RETURN
   
   PROCEDURE FillGridCities
      IF ConectMe() 
        IF TryToLock()
          aTableCities := sql(oDataBase,GsReadQuery)
          DeleteFileLock()
        ELSE
          RETURN
        ENDIF
        
         IF LEN (aTableCities) = 0
            MsgExclamation ("No hay ciudades que mostrar")
            RETURN
         ELSE
            Frm_ShowCities.Grd_Cities.DeleteAllItems
            FOR i := 1 to LEN (aTableCities)
               Frm_ShowCities.Grd_Cities.AddItem ({ aTableCities[i,1],ALLTRIM(STR(aTableCities[i,2])) })
            NEXT i
         ENDIF
         Frm_ShowCities.Grd_Cities.Value := 1
         Frm_ShowCities.Grd_Cities.SetFocus
      ENDIF
   RETURN
 
   PROCEDURE FindDataCity
* Busca ciudades parecidas a lo tecleado 
      GsReadQuery := "SELECT Name, City_Id FROM Cities "
      GsReadQuery += "WHERE Country_id = " +C2SQL(LnCountryId) 
      GsReadQuery += " AND State_Id = "+C2SQL(LnStateId)
      GsReadQuery += " AND Name LIKE '%" + ALLTRIM(Frm_ShowCities.Txt_IndividualData.VALUE) + "%' "
      GsReadQuery += "AND IS_Visible > 0 ORDER BY Name"   
      aGetTableData := sql(oDataBase,GsReadQuery)
      FillGridCities()
   RETURN

   PROCEDURE GetCity
      GnData1 := VAL (ColumnGridValue("Grd_Cities", "Frm_ShowCities", 2))
      GsData1 := ALLTRIM (ColumnGridValue("Grd_Cities", "Frm_ShowCities", 1))
      ExitShowCities()
   RETURN

   PROCEDURE ExitShowCities
      Frm_ShowCities.Release
   RETURN

RETURN
