﻿#INCLUDE <hmg.ch>
#INCLUDE "hbver.ch"
#INCLUDE <PS_Posoft.ch>

PROCEDURE UpdatePurchaseOrder
   PRIVATE LnNewPOStatus := LnOldPOStatus := LnPurchaseId := 0
   
   SET TOOLTIPSTYLE BALLOON
   IF IsWindowActive (Frm_UpdatePO)
      MsgStop("Ya esta en en uso esta opción","ERROR")
      RETURN NIL
   ELSE
      LOAD WINDOW Frm_UpdatePO
      END WINDOW
      GsStateName := GsCityName := ""
      SwitchPOUpdate(0)
      CENTER WINDOW Frm_UpdatePO
      ACTIVATE WINDOW Frm_UpdatePO
   ENDIF

PROCEDURE SwitchPOUpdate(Switch)
   DO CASE 
      CASE Switch == 0
			Frm_UpdatePO.Txt_PONum.Value := 0
			Frm_UpdatePO.Txt_NewPoStatus.Value := ""
			Frm_UpdatePO.Txt_Provider.Value := ""
			Frm_UpdatePO.Txt_PODate.Value := ""
			Frm_UpdatePO.Txt_CurrentPOStatus.Value := ""
			Frm_UpdatePO.Edt_PONote.Value := ""

			Frm_UpdatePO.Btn_SeaarchPO.Enabled := .T.
			Frm_UpdatePO.Btn_SeaarchPO.SetFocus
          
		CASE Switch== 1
			Frm_UpdatePO.Txt_PONum.Value := 0
			Frm_UpdatePO.Txt_NewPoStatus.Value := ""
			Frm_UpdatePO.Txt_Provider.Value := ""
			Frm_UpdatePO.Txt_PODate.Value := ""
			Frm_UpdatePO.Txt_CurrentPOStatus.Value := ""
			Frm_UpdatePO.Edt_PONote.Value := "" 
   END CASE
RETURN

PROCEDURE FindPO
   GnData1 := 0
   GsData1 := GsData2 := GsData3 := GsData4 := ""
   SwitchPOUpdate(1) 
   LnPurchaseId := 0
   ShowPurchaseOrderHeader()   
   Frm_UpdatePO.Txt_PONum.Value := GnData1      
   LnPurchaseId := GnData1             
   LnOldPOStatus := GnData2
   Frm_UpdatePO.Txt_Provider.Value := GsData1
   Frm_UpdatePO.Txt_CurrentPOStatus.Value := GsData2
   Frm_UpdatePO.Txt_PODate.Value := GsData3
   Frm_UpdatePO.Edt_PONote.Value := GsData4
   
RETURN

PROCEDURE FindNewPOStatus
   GsData1 := ""
   GnData1 := 0
   ShowStandardStatus(6)
   Frm_UpdatePO.Txt_NewPoStatus.Value := GsData1
   LnNewPOStatus := GnData1 
RETURN

PROCEDURE UpdatePO
// Verifica si es posible realizar la actualización del estatus
   DO CASE 
      CASE LnOldPOStatus = 2 .AND. LnNewPOStatus =  100
         MsgExclamation("Imposible cambiar el estatus ya que esta orde de compra"+HB_OSNewLine()+;
                        "ya fue recibida.")
         Frm_UpdatePO.Btn_SearchNewPOStatus.SetFocus 
         RETURN
      CASE LnOldPOStatus = 3  .AND. LnNewPOStatus =  100
         MsgExclamation("Imposible cambiar el estatus ya que esta orde de compra"+HB_OSNewLine()+;
                        "ya fue ingresada al inventario.")
         Frm_UpdatePO.Btn_SearchNewPOStatus.SetFocus
         RETURN     
      CASE LnOldPOStatus = 4 .AND. LnNewPOStatus =  100
         MsgExclamation("Imposible cambiar el estatus ya que esta orde de compra"+HB_OSNewLine()+;
                        "está pendiente de ser pagada al proveedor.")
         Frm_UpdatePO.Btn_SearchNewPOStatus.SetFocus
         RETURN
      CASE LnOldPOStatus = 5 .AND. LnNewPOStatus =  100
         MsgExclamation("Imposible cambiar el estatus ya que esta orde de compra"+HB_OSNewLine()+;
                        "ya fue pagada.")        
         Frm_UpdatePO.Btn_SearchNewPOStatus.SetFocus
         RETURN
      CASE LnOldPOStatus > LnNewPOStatus
         MsgExclamation("Imposible cambiar el estatus ya que esta orde de compra"+HB_OSNewLine()+;
                        "tiene un estatus mayor al que nuevo.")
         RETURN
   END CASE
   GsQueryInsert := "UPDATE Purchase SET Purchase_Status_Id = "
   GsQueryInsert += C2SQL(LnNewPOStatus) 
   GsQueryInsert += " WHERE Purchase_Id = "+C2SQL(Frm_UpdatePO.Txt_PONum.Value)
	IF TryToLock()
		 IF BeforeSave(GsQueryInsert)
			MsgInfo ("Registro actualizado.")
			DeleteFileLock()
		 ELSE
			MsgExclamation ("Error al tratar de actualizar la orden de compra.")
		 ENDIF   
	ENDIF
	SwitchPOUpdate(0)
RETURN 

PROCEDURE ExitUpdatePO
   Frm_UpdatePO.RELEASE
RETURN
RETURN 