﻿#INCLUDE <hmg.ch>
#INCLUDE "hbver.ch"
#INCLUDE <PS_Posoft.ch>

PROCEDURE Warehouse
   PRIVATE LnWarehouseId := LnStateId := LnCityId :=  0
   PRIVATE LsWarehouseName := LsCityName := LsStateName := ""
   PRIVATE aGetTableData:= {}
   PRIVATE GbIsNew := .T.
   LoadMyData()
   SET TOOLTIPSTYLE BALLOON
   IF IsWindowActive (Frm_Warehouse)
      MsgStop("Ya esta en en uso esta opción","ERROR")
      RETURN NIL
   ELSE
      LOAD WINDOW Frm_Warehouse
      END WINDOW
			IF .NOT. ConectMe()
			  RETURN
			ENDIF
      WarehouseSwitch(0)
      CENTER WINDOW Frm_Warehouse
      ACTIVATE WINDOW Frm_Warehouse
   ENDIF

PROCEDURE WarehouseSwitch(Switch)
   DO CASE
      CASE Switch == 0      // Todo apagado e inhibido
         Frm_Warehouse.Btn_New.Enabled        := .T.
         Frm_Warehouse.Btn_Edit.Enabled       := .F.
         Frm_Warehouse.Btn_Delete.Enabled     := .F.
         Frm_Warehouse.Btn_Back.Enabled       := .F.
         Frm_Warehouse.Btn_Save.Enabled       := .F.
         Frm_Warehouse.Btn_SeeDetail.Enabled  := .T.
         Frm_Warehouse.Btn_FillItUp.Enabled   := .T.
         Frm_Warehouse.Btn_Print.Enabled      := .F.
         Frm_Warehouse.Btn_Exit.Enabled       := .T.

         Frm_Warehouse.Btn_FindCity.Enabled         := .F.
         Frm_Warehouse.Btn_FindState.Enabled        := .F.
         Frm_Warehouse.Txt_FindIndividual.Visible   := .F.
         Frm_Warehouse.Fra_FindIndividualData.Visible   := .F.
         Frm_Warehouse.Btn_FindIndividual.Visible   := .F.

         Frm_Warehouse.Txt_WarehouseName.Value       := ""
         Frm_Warehouse.Txt_Address1.Value           := ""
         Frm_Warehouse.Txt_Address2.Value           := ""
         Frm_Warehouse.Txt_StateName.Value          := ""
         Frm_Warehouse.Txt_CityName.Value           := ""
         Frm_Warehouse.Txt_ZipCode.Value            := ""
         Frm_Warehouse.Txt_CodeArea.Value           := ""
         Frm_Warehouse.Txt_PhoneOffice.Value        := ""
         Frm_Warehouse.Txt_FiscalId.Value           := ""
         Frm_Warehouse.Txt_WarehouseName.Enabled     := .F.
         Frm_Warehouse.Txt_Address1.Enabled         := .F.
         Frm_Warehouse.Txt_Address2.Enabled         := .F.
         Frm_Warehouse.Txt_StateName.Enabled        := .F.
         Frm_Warehouse.Txt_CityName.Enabled         := .F.
         Frm_Warehouse.Txt_ZipCode.Enabled          := .F.
         Frm_Warehouse.Txt_CodeArea.Enabled         := .F.
         Frm_Warehouse.Txt_PhoneOffice.Enabled      := .F.
         Frm_Warehouse.Txt_FiscalId.Enabled         := .F.
         Frm_Warehouse.Txt_InChargeName.Enabled       := .F.
         Frm_Warehouse.Txt_InChargeEMail.Enabled      := .F.
         Frm_Warehouse.Txt_InChargeMovil.Enabled      := .F.

      CASE Switch == 1      // New después de verificar "IfExistsWarehouse"
         Frm_Warehouse.Btn_New.Enabled           := .F.
         Frm_Warehouse.Btn_Edit.Enabled          := .F.
         Frm_Warehouse.Btn_Delete.Enabled        := .F.
         Frm_Warehouse.Btn_Exit.Enabled          := .F.
         Frm_Warehouse.Btn_Print.Enabled         := .F.
         Frm_Warehouse.Btn_SeeDetail.Enabled     := .F.
         Frm_Warehouse.Btn_Save.Enabled          := .T.
         Frm_Warehouse.Btn_Back.Enabled          := .T.
         Frm_Warehouse.Btn_FillItUp.Enabled      := .F.
         Frm_Warehouse.Btn_FindState.Enabled     := .T.
         Frm_Warehouse.Btn_FindCity.Enabled      := .T.

         Frm_Warehouse.Txt_WarehouseName.Enabled  := .T.
         Frm_Warehouse.Txt_Address1.Enabled      := .T.
         Frm_Warehouse.Txt_address2.Enabled      := .T.
         Frm_Warehouse.Txt_StateName.Enabled     := .T.
         Frm_Warehouse.Txt_CityName.Enabled      := .T.
         Frm_Warehouse.Txt_ZipCode.Enabled       := .T.
         Frm_Warehouse.Txt_CodeArea.Enabled      := .T.
         Frm_Warehouse.Txt_PhoneOffice.Enabled   := .T.
         Frm_Warehouse.Txt_FiscalId.Enabled      := .T.
         Frm_Warehouse.Txt_InChargeName.Enabled       := .T.
         Frm_Warehouse.Txt_InChargeEMail.Enabled      := .T.
         Frm_Warehouse.Txt_InChargeMovil.Enabled      := .T.

      CASE Switch == 2      // Desiste de la captura
         Frm_Warehouse.Btn_New.Enabled        := .F.
         Frm_Warehouse.Btn_Edit.Enabled       := .F.
         Frm_Warehouse.Btn_Delete.Enabled     := .F.
         Frm_Warehouse.Btn_Back.Enabled       := .T.
         Frm_Warehouse.Btn_Save.Enabled       := .F.
         Frm_Warehouse.Btn_SeeDetail.Enabled  := .F.
         Frm_Warehouse.Btn_FillItUp.Enabled   := .F.
         Frm_Warehouse.Btn_Print.Enabled      := .F.
         Frm_Warehouse.Btn_Exit.Enabled       := .F.

      CASE Switch == 3      // Consulta por codigo cliente.
         Frm_Warehouse.Btn_New.Enabled        := .F.
         Frm_Warehouse.Btn_Edit.Enabled       := .F.
         Frm_Warehouse.Btn_Delete.Enabled     := .F.
         Frm_Warehouse.Btn_Exit.Enabled       := .F.
         Frm_Warehouse.Btn_Print.Enabled      := .F.
         Frm_Warehouse.Btn_SeeDetail.Enabled  := .F.
         Frm_Warehouse.Btn_Save.Enabled       := .T.
         Frm_Warehouse.Btn_Back.Enabled       := .T.
         Frm_Warehouse.Btn_FillItUp.Enabled   := .F.

      CASE Switch = 10     // Limpia los campos a captura
         GbIsNew := .T.
         Frm_Warehouse.Btn_New.Enabled        := .F.
         Frm_Warehouse.Btn_Edit.Enabled       := .F.
         Frm_Warehouse.Btn_Delete.Enabled     := .F.
         Frm_Warehouse.Btn_Back.Enabled       := .T.
         Frm_Warehouse.Btn_Save.Enabled       := .T.
         Frm_Warehouse.Btn_SeeDetail.Enabled  := .F.
         Frm_Warehouse.Btn_FillItUp.Enabled   := .F.
         Frm_Warehouse.Btn_Print.Enabled      := .F.
         Frm_Warehouse.Btn_Exit.Enabled       := .F.

         Frm_Warehouse.Txt_FindIndividual.Visible   := .F.
         Frm_Warehouse.Fra_FindIndividualData.Visible   := .F.

         Frm_Warehouse.Txt_WarehouseName.Value := ""
         Frm_Warehouse.Txt_Address1.Value := ""
         Frm_Warehouse.Txt_Address2.Value := ""
         Frm_Warehouse.Txt_StateName.Value := ""
         Frm_Warehouse.Txt_CityName.Value := ""
         Frm_Warehouse.Txt_ZipCode.Value := ""
         Frm_Warehouse.Txt_CodeArea.Value := ""
         Frm_Warehouse.Txt_PhoneOffice.Value := ""
         Frm_Warehouse.Txt_FiscalId.Value := ""
         Frm_Warehouse.Txt_InChargeName.Value := ""
         Frm_Warehouse.Txt_InChargeEMail.Value := ""
         Frm_Warehouse.Txt_InChargeMovil.Value := ""

         Frm_Warehouse.Btn_FindState.Enabled     := .T.
         Frm_Warehouse.Btn_FindCity.Enabled      := .T.

         Frm_Warehouse.Txt_WarehouseName.Enabled  := .T.
         Frm_Warehouse.Txt_Address1.Enabled      := .T.
         Frm_Warehouse.Txt_address2.Enabled      := .T.
         Frm_Warehouse.Txt_StateName.Enabled     := .T.
         Frm_Warehouse.Txt_CityName.Enabled      := .T.
         Frm_Warehouse.Txt_ZipCode.Enabled       := .T.
         Frm_Warehouse.Txt_CodeArea.Enabled      := .T.
         Frm_Warehouse.Txt_PhoneOffice.Enabled   := .T.
         Frm_Warehouse.Txt_FiscalId.Enabled      := .T.
         Frm_Warehouse.Txt_ZipCode.Enabled      := .T.
         Frm_Warehouse.Txt_InChargeName.Enabled       := .T.
         Frm_Warehouse.Txt_InChargeEMail.Enabled      := .T.
         Frm_Warehouse.Txt_InChargeMovil.Enabled      := .T.

         Frm_Warehouse.Txt_WarehouseName.SetFocus

   ENDCASE
RETURN

PROCEDURE NewWarehouseData
   GbIsNew := .T.
   WarehouseSwitch(10)
RETURN

PROCEDURE ModifyWarehouse
  IF Frm_Warehouse.Grd_Warehouse.Value = 0
    MsgInfo("Selecciona un proveedor.")
    Frm_Warehouse.Grd_Warehouse.Value := 1
    Frm_Warehouse.Grd_Warehouse.SetFocus
    RETURN
  ELSE
   GetWarehouseData()
   LsWarehouseId := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 1)
   GbIsNew := .F.
   WarehouseSwitch(1)
   Frm_Warehouse.Txt_WarehouseName.SetFocus
  ENDIF
RETURN

PROCEDURE GetWarehouseData
  LnWarehouseId                           := VAL(ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 1 ))
  Frm_Warehouse.Txt_WarehouseName.Value    := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 2 )
  Frm_Warehouse.Txt_Address1.Value        := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 3 )
  Frm_Warehouse.Txt_Address2.Value        := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 4 )
  LnStateId                              := VAL(ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse",5 ))
  LnCityId                               := VAL(ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse",6 ))
  Frm_Warehouse.Txt_ZipCode.Value         := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 7 )
  Frm_Warehouse.Txt_CodeArea.Value        := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 8 )
  Frm_Warehouse.Txt_PhoneOffice.Value     := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 9 )
  Frm_Warehouse.Txt_FiscalId.Value        := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 10 )
  Frm_Warehouse.Txt_StateName.Value       := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 11 )
  Frm_Warehouse.Txt_CityName.Value        := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 12 )
  Frm_Warehouse.Txt_InChargeName.Value        := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 13 )
  Frm_Warehouse.Txt_InChargeEMail.Value        := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 14 )
  Frm_Warehouse.Txt_InChargeMovil.Value        := ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 15 )
RETURN

PROCEDURE GetDataWarehouses
	Frm_Warehouse.Grd_Warehouse.DeleteAllItems
   GsReadQuery :="SELECT "
   GsReadQuery += "w.Warehouse_Id, "
   GsReadQuery += "w.Name, "
   GsReadQuery += "w.Address_1, "
   GsReadQuery += "w.Address_2, "
   GsReadQuery += "w.State_Id, "
   GsReadQuery += "w.City_Id, "
   GsReadQuery += "w.Postal_Code, "
   GsReadQuery += "w.Code_Area, "
   GsReadQuery += "w.Phone_Office, "
   GsReadQuery += "w.Fiscal_Id, "
   GsReadQuery += "IFNULL(s.Name,'') AS State_Name, "
   GsReadQuery += "IFNULL(c.Name,'') AS City_Name, "
   GsReadQuery += "w.In_Charge_Name, "
   GsReadQuery += "w.In_Charge_EMail, "
   GsReadQuery += "w.In_Charge_Movil "
   GsReadQuery += "FROM Warehouse AS w "
   GsReadQuery += "LEFT JOIN STATES AS s ON s.State_Id = w.State_Id "
   GsReadQuery += "LEFT JOIN CITIES AS c ON c.City_Id = w.City_Id "
   GsReadQuery += " WHERE w.IS_VISIBLE = 1 "
   GsReadQuery += "ORDER BY w.Name"
   IF TryToLock()
    aGetTableData := ReadData (GsReadQuery)
    DeleteFileLock()
   ENDIF

	IF LEN (aGetTableData) > 0
	 FillItUpWarehouse(aGetTableData)
	ELSE
	 MsgExclamation ( "No existe ningún almacén en la base de datos." )
	ENDIF
RETURN(aGetTableData)

PROCEDURE IfExistsWarehouse
  IF GbIsNew
   GsReadQuery :="SELECT "
   GsReadQuery += "w.Warehouse_Id, "
   GsReadQuery += "w.Name, "
   GsReadQuery += "w.Address_1, "
   GsReadQuery += "w.Address_2, "
   GsReadQuery += "w.State_Id, "
   GsReadQuery += "w.City_Id, "
   GsReadQuery += "w.Postal_Code, "
   GsReadQuery += "w.Code_Area, "
   GsReadQuery += "w.Phone_Office, "
   GsReadQuery += "w.Fiscal_Id, "
   GsReadQuery += "IFNULL(s.Name,'') AS State_Name, "
   GsReadQuery += "IFNULL(c.Name,'') AS City_Name, "
   GsReadQuery += "w.In_Charge_Name, "
   GsReadQuery += "w.In_Charge_EMail, "
   GsReadQuery += "w.In_Caherge_Movil "
   GsReadQuery += "FROM Warehouse AS w "
   GsReadQuery += "LEFT JOIN STATES AS s ON s.State_Id = w.State_Id "
   GsReadQuery += "LEFT JOIN CITIES AS c ON c.City_Id = w.City_Id "
    GsReadQuery += "WHERE w.Name = "+C2SQL(ALLTRIM(Frm_Warehouse.Txt_WarehouseName.Value))
    GsReadQuery += " AND w.IS_VISIBLE = 1 "

		 IF TryToLock()
			 aGetTableData := ReadData (GsReadQuery)
			 DeleteFileLock()
		 ENDIF

		 IF LEN (aGetTableData) > 0
			 LnWarehouseId                             := aGetTableData[1,1]
			 Frm_Warehouse.Txt_WarehouseName.Value      := aGetTableData[1,2]
			 Frm_Warehouse.Txt_Address1.Value          := aGetTableData[1,3]
			 Frm_Warehouse.Txt_Address2.Value          := aGetTableData[1,4]
			 LnStateId                                := aGetTableData[1,5]
			 LnCityId                                 := aGetTableData[1,6]
			 Frm_Warehouse.Txt_ZipCode.Value           := aGetTableData[1,7]
			 Frm_Warehouse.Txt_CodeArea.Value          := aGetTableData[1,8]
			 Frm_Warehouse.Txt_PhoneOffice.Value       := aGetTableData[1,9]
       Frm_Warehouse.Txt_FiscalId.Value          := aGetTableData[1,10]
			 Frm_Warehouse.Txt_StateName.Value         := aGetTableData[1,11]
			 Frm_Warehouse.Txt_CityName.Value          := aGetTableData[1,12]
       Frm_Warehouse.Txt_InChargeName.Value         := aGetTableData[1,13]
			 Frm_Warehouse.Txt_InChargeEMail.Value        := aGetTableData[1,14]
			 Frm_Warehouse.Txt_InChargeMovil.Value        := aGetTableData[1,15]
		 ELSE
			 Frm_Warehouse.Txt_Address1.Value          := ""
			 Frm_Warehouse.Txt_Address2.Value          := ""
			 LnStateId                                := 0
			 LnCityId                                 := 0
			 Frm_Warehouse.Txt_ZipCode.Value           := ""
			 Frm_Warehouse.Txt_CodeArea.Value          := ""
			 Frm_Warehouse.Txt_PhoneOffice.Value       := ""
			 Frm_Warehouse.Txt_FiscalId.Value          := ""
			 Frm_Warehouse.Txt_StateName.Value         := ""
			 Frm_Warehouse.Txt_CityName.Value          := ""
		 ENDIF
  ENDIF
RETURN

PROCEDURE FillItUpWarehouse
	Frm_Warehouse.Grd_Warehouse.DeleteAllItems
  FOR i := 1 TO LEN (aGetTableData)
			Frm_Warehouse.Grd_Warehouse.AddItem ( {  ALLTRIM(STR(aGetTableData[i,1])), +;
			aGetTableData[i,2], +;
			aGetTableData[i,3], +;
			aGetTableData[i,4], +;
			STR(aGetTableData[i,5]), +;
			STR(aGetTableData[i,6]), +;
			aGetTableData[i,7], +;
			aGetTableData[i,8], +;
			aGetTableData[i,9], +;
			aGetTableData[i,10], +;
			aGetTableData[i,11], +;
			aGetTableData[i,12], +;
			aGetTableData[i,13], +;
			aGetTableData[i,14], ;
      aGetTableData[i,15]  })
	NEXT i

	IF Frm_Warehouse.Grd_Warehouse.ItemCount > 0
		Frm_Warehouse.Btn_Edit.Enabled := .T.
		Frm_Warehouse.Btn_Delete.Enabled := .T.
		Frm_Warehouse.Btn_Print.Enabled := .T.
	ELSE
		Frm_Warehouse.Btn_Edit.Enabled := .F.
		Frm_Warehouse.Btn_Delete.Enabled := .F.
		Frm_Warehouse.Btn_Print.Enabled := .F.
	ENDIF
RETURN

PROCEDURE SaveWarehouse
   GdDateSQL := "DATE('NOW')"
   GsTimeSQL := "TIME('NOW','LOCALTIME')"
   IF CheckBeforeSaveWarehouse()
    IF TryToLock()
      IF GbIsNew
// Inserta o actualiza el registro.
			  GsQuery := "INSERT INTO Warehouse ("
        GsQuery += "Warehouse_Id, "
        GsQuery += "Name, "
        GsQuery += "Address_1, "
        GsQuery += "Address_2, "
        GsQuery += "State_Id, "
        GsQuery += "City_Id, "
        GsQuery += "Postal_Code, "
        GsQuery += "Code_Area, "
        GsQuery += "Phone_Office, "
        GsQuery += "Fiscal_Id, "
        GsQuery += "In_Charge_Name, "
        GsQuery += "In_Charge_EMail, "
        GsQuery += "In_Charge_Movil, "
        GsQuery += "Is_Visible, "
        GsQuery += "Prog_Name, "
        GsQuery += "Entry_Date, "
        GsQuery += "Entry_Time) VALUES ("
        GsQuery += C2SQL(GetNextNumber("warehouse_id")) + ","
        GsQuery += C2SQL(Frm_Warehouse.Txt_WarehouseName.Value) + ","
        GsQuery += C2SQL(Frm_Warehouse.Txt_Address1.Value) + ","
        GsQuery += C2SQL(Frm_Warehouse.Txt_Address2.Value) + ","
        GsQuery += C2SQL(LnStateId) + ","
        GsQuery += C2SQL(LnCityId) + ","
        GsQuery += C2SQL(Frm_Warehouse.Txt_ZipCode.Value) + ","
        GsQuery += C2SQL(Frm_Warehouse.Txt_CodeArea.Value) + ","
        GsQuery += C2SQL(Frm_Warehouse.Txt_PhoneOffice.Value) + ","
        GsQuery += C2SQL(Frm_Warehouse.Txt_FiscalId.Value) + ","
        GsQuery += C2SQL(Frm_Warehouse.Txt_InChargeName.Value) + ","
        GsQuery += C2SQL(Frm_Warehouse.Txt_InChargeEMail.Value) + ","
        GsQuery += C2SQL(Frm_Warehouse.Txt_InChargeMovil.Value) + ","
        GsQuery += C2SQL(1) + ", "
        GsQuery += C2SQL(PROCNAME()) + ","
        GsQuery += GdDateSQL+", "
        GsQuery += GsTimeSQL +")"
  		ELSE
        GsQuery := "UPDATE Warehouse SET "
        GsQuery += "Warehouse_Id = " + C2SQL(LnWarehouseId) + ","
        GsQuery += "Name = " + C2SQL(Frm_Warehouse.Txt_WarehouseName.Value) + ","
        GsQuery += "Address_1 = " + C2SQL(Frm_Warehouse.Txt_Address1.Value) + ","
        GsQuery += "Address_2 = " + C2SQL(Frm_Warehouse.Txt_Address2.Value) + ","
        GsQuery += "State_id = " + C2SQL(LnStateId) + ","
        GsQuery += "City_Id = " + C2SQL(LnCityId) + ","
        GsQuery += "Postal_Code = " + C2SQL(Frm_Warehouse.Txt_ZipCode.Value) + ","
        GsQuery += "Code_Area = " + C2SQL(Frm_Warehouse.Txt_CodeArea.Value) + ","
        GsQuery += "Phone_Office = " + C2SQL(Frm_Warehouse.Txt_PhoneOffice.Value) + ","
        GsQuery += "Fiscal_Id = " + C2SQL(Frm_Warehouse.Txt_FiscalId.Value) + ","
        GsQuery += "In_Charge_Name = " + C2SQL(Frm_Warehouse.Txt_InChargeName.Value) + ","
        GsQuery += "In_Charge_EMail = " + C2SQL(Frm_Warehouse.Txt_InChargeEMail.Value) + ","
        GsQuery += "In_Charge_Movil = " + C2SQL(Frm_Warehouse.Txt_InChargeMovil.Value) + ","
        GsQuery += "Prog_Name = " + C2SQL(PROCNAME()) + ","
        GsQuery += "Modify_Date = " + GdDateSQL +", "
        GsQuery += "Modify_Time = " + GsTimeSQL
        GsQuery += "WHERE Warehouse_Id = " + C2SQL(LnWarehouseId)
  		ENDIF
        IF BeforeSave(GsQuery)
          MsgInfo ( IIF (GbIsNew,"Registro insertado o actualizado.","Registro actualizado"+HB_OSNewLine()+"Cargue de nuevo los datos."))
          DeleteFileLock()
        ELSE
         MsgExclamation ("Error al tratar de insertar, actualizar.")
        ENDIF
      ELSE
        RETURN
      ENDIF
      WarehouseSwitch(0)
  ENDIF
 RETURN

PROCEDURE ExistsWarehouse
   GsReadQuery :="SELECT "
   GsReadQuery += "w.Warehouse_Id, "
   GsReadQuery += "w.Name, "
   GsReadQuery += "w.Address_1, "
   GsReadQuery += "w.Address_2, "
   GsReadQuery += "w.State_Id, "
   GsReadQuery += "w.City_Id, "
   GsReadQuery += "w.Postal_Code, "
   GsReadQuery += "w.Code_Area, "
   GsReadQuery += "w.Phone_Office, "
   GsReadQuery += "w.Fiscal_Id, "
   GsReadQuery += "IFNULL(s.Name,'') AS State_Name, "
   GsReadQuery += "IFNULL(c.Name,'') AS City_Name, "
   GsReadQuery += "w.In_Charge_Name, "
   GsReadQuery += "w.In_Charge_EMail, "
   GsReadQuery += "w.In_Charge_Movil "
   GsReadQuery += "FROM Warehouse AS p "
   GsReadQuery += "LEFT JOIN STATES AS s ON s.State_Id = w.State_Id "
   GsReadQuery += "LEFT JOIN CITIES AS c ON c.City_Id = w.City_Id "
   GsReadQuery += "WHERE w.Warehouse_Id = " + C2SQL(LnWarehouseId)

  IF TryToLock()
   aGetTableData := ReadData (GsReadQuery)
   DeleteFileLock()
  ENDIF

   IF LEN (aGetTableData) > 0
      GbIsNew := .F.
      FOR i := 1 TO LEN (aGetTableData)
        LnWarehouseId                            := aGetTableData[i,1]
        Frm_Warehouse.Txt_WarehouseName.Value     := aGetTableData[i,2]
        Frm_Warehouse.Txt_Address1.Value         := aGetTableData[i,3]
        Frm_Warehouse.Txt_Address2.Value         := aGetTableData[i,4]
        LnStateId                               := STR(aGetTableData[i,5])
        LnCityId                                := STR(aGetTableData[i,6])
        Frm_Warehouse.Txt_ZipCode.Value          := aGetTableData[i,7]
        Frm_Warehouse.Txt_CodeArea.Value         := aGetTableData[i,8]
        Frm_Warehouse.Txt_PhoneOffice.Value      := aGetTableData[i,9]
        Frm_Warehouse.Txt_FiscalId.Value         := aGetTableData[i,10]
        Frm_Warehouse.Txt_StateName.Value        := aGetTableData[i,11]
        Frm_Warehouse.Txt_CityName.Value         := aGetTableData[i,12]
        Frm_Warehouse.Txt_InChargeName.Value         := aGetTableData[1,13]
			  Frm_Warehouse.Txt_InChargeEMail.Value        := aGetTableData[1,14]
			  Frm_Warehouse.Txt_InChargeMovil.Value        := aGetTableData[1,15]
      NEXT i
   ELSE
      GbIsNew := .T.
   ENDIF
//  ENDIF
RETURN

PROCEDURE UndoWarehouse
   WarehouseSwitch(0)
RETURN

PROCEDURE DropWarehouse
   LOCAL LnGridRow
   LsWarehouseId := VAL(ColumnGridValue( "Grd_Warehouse", "Frm_Warehouse", 1))
   LnGridRow := Frm_Warehouse.Grd_Warehouse.Value
   GsReadQuery := "SELECT PS_Id, Warehouse_Id, Name FROM Warehouse "
   GsReadQuery += "WHERE Warehouse_Id = " + C2SQL(LnWarehouseId)
  IF TryToLock()
      aGetTableData := ReadData (GsReadQuery)
      DeleteFileLock()
  ENDIF

	IF LEN (aGetTableData) > 0
		  Frm_Warehouse.Txt_WarehouseName.Value := aGetTableData[1,3]
		IF MsgYesNo("¿Desea eliminar este almacén?:"+HB_OSNewLine()+ Frm_Warehouse.Txt_WarehouseName.Value,"¡Borrar!")
		  GsQueryDelete :="DELETE FROM Warehouse WHERE Warehouse_Id = " + C2SQL(LnWarehouseId)
		  IF TryToLock()
				IF BeforeSave(GsQueryDelete)
				  MsgInfo ( "Registro ha sido eliminado."+HB_OSNewLine()+"Cargue de nuevo los datos.")
				  DeleteFileLock()
				ELSE
				  MsgExclamation ("Error al tratar de borrar el almacén")
				ENDIF
			ENDIF
		ENDIF
	ENDIF

 RETURN

PROCEDURE EditWarehouse
   WarehouseSwitch(2)
RETURN

PROCEDURE FindOneWarehouse
   Frm_Warehouse.Btn_Back.Enabled := .T.
   Frm_Warehouse.Btn_Exit.Enabled := .F.
   Frm_Warehouse.Btn_SeeDetail.Enabled := .T.
   Frm_Warehouse.Btn_New.Enabled := .F.
   Frm_Warehouse.Btn_FillItUp.Enabled := .F.
   Frm_Warehouse.Txt_FindIndividual.Visible   := .T.
   Frm_Warehouse.Fra_FindIndividualData.Visible   := .T.
   Frm_Warehouse.Btn_FindIndividual.Visible   := .T.
   Frm_Warehouse.Txt_FindIndividual.Value := ""
   Frm_Warehouse.Txt_FindIndividual.SetFocus
RETURN

PROCEDURE FindIndividualWarehouse
   Frm_Warehouse.Btn_New.Enabled := .F.
   Frm_Warehouse.Btn_FillItUp.Enabled := .F.
   Frm_Warehouse.Btn_Delete.Enabled := .T.
   Frm_Warehouse.Btn_Edit.Enabled := .T.
   Frm_Warehouse.Btn_Back.Enabled := .T.
   Frm_Warehouse.Btn_SeeDetail.Enabled := .T.
   Frm_Warehouse.Btn_Print.Enabled := .T.
   Frm_Warehouse.Fra_FindIndividualData.Visible := .T.
   Frm_Warehouse.Txt_FindIndividual.Visible := .T.
   LsToSearch := ALLTRIM ( Frm_Warehouse.Txt_FindIndividual.Value )
   GsReadQuery :="SELECT "
   GsReadQuery += "w.Warehouse_Id, "
   GsReadQuery += "w.Name, "
   GsReadQuery += "w.Address_1, "
   GsReadQuery += "w.Address_2, "
   GsReadQuery += "w.State_Id, "
   GsReadQuery += "w.City_Id, "
   GsReadQuery += "w.Postal_Code, "
   GsReadQuery += "w.Code_Area, "
   GsReadQuery += "w.Phone_Office, "
   GsReadQuery += "w.Fiscal_Id, "
   GsReadQuery += "IFNULL(s.Name,'') AS State_Name, "
   GsReadQuery += "IFNULL(c.Name,'') AS City_Name, "
   GsReadQuery += "w.In_Charge_Name, "
   GsReadQuery += "w.In_Charge_EMail, "
   GsReadQuery += "w.In_Charge_Movil "
   GsReadQuery += "FROM Warehouse AS w "
   GsReadQuery += "LEFT JOIN STATES AS s ON s.State_Id = w.State_Id "
   GsReadQuery += "LEFT JOIN CITIES AS c ON c.City_Id = w.City_Id "
   GsReadQuery += "WHERE w.Is_Visible = 1 "
   GsReadQuery += "AND w.Name LIKE '%" + LsToSearch + "%' "
   IF TryToLock()
			aGetTableData := ReadData (GsReadQuery)
			DeleteFileLock()
   ENDIF
	 IF LEN (aGetTableData) = 0
			MsgExclamation ( "No se encontro ningun dato similiar al deseado." )
			Frm_Warehouse.Txt_FindIndividual.SetFocus
			RETURN
	 ELSE
      FillItUpWarehouse(aGetTableData)
   ENDIF
RETURN

PROCEDURE PrintWarehouseData
RETURN

PROCEDURE ExitWarehouse
   Frm_Warehouse.Release
RETURN

PROCEDURE FindWarehouseState
   LnStateId := LnCityId := 0
   LsStateName := LsCityName := ""
   Frm_Warehouse.Txt_StateName.Value := ""
   Frm_Warehouse.Txt_CityName.Value := ""
   ShowStates(55)
   LnStateId := GnData1
   LsStateName := GsData1
   Frm_Warehouse.Txt_StateName.Value := LsStateName
   Frm_Warehouse.Btn_FindCity.SetFocus
RETURN

PROCEDURE FindWarehouseCity
   LsCityName := ""
   LnCityId := 0
   Frm_Warehouse.Txt_CityName.Value := ""
   ShowCities(55, LnStateId)
   LnCityId := GnData1
   LsCityName := GsData1
   Frm_Warehouse.Txt_CityName.Value := LsCityName
   Frm_Warehouse.Txt_ZipCode.SetFocus
RETURN

FUNCTION CheckBeforeSaveWarehouse
  LOCAL LbReturn := .T.

    IF EMPTY (Frm_Warehouse.Txt_WarehouseName.Value)
      MsgExclamation ( "Ingresa el nombre del almacén" , "¡Error!" )
      Frm_Warehouse.Txt_WarehouseName.SetFocus
      RETURN(.F.)
    ENDIF

    IF EMPTY (Frm_Warehouse.Txt_StateName.Value) .OR. EMPTY ( Frm_Warehouse.Txt_CityName.Value )
      MsgExclamation ( "Selecciona el estado y/o ciudad." , "¡Error!" )
      Frm_Warehouse.Btn_FindState.SetFocus
      RETURN(.F.)
    ENDIF

    IF .NOT. EMPTY(Frm_Warehouse.Txt_WarehouseName.Value)
      GsReadQuery := "SELECT Name FROM Warehouse WHERE "
      GsReadQuery += "Name = "
      GsReadQuery += C2SQL(ALLTRIM(Frm_Warehouse.Txt_WarehouseName.Value))
      IF TryToLock()
        aCheckData := ReadData(GsReadQuery)
        DeleteFileLock()
      ENDIF

      IF LEN(aCheckData) > 0 .AND. GbIsNew
        MsgExclamation("Ya existe ese nombre de almacén en la base de datos,"+HB_OSNewLine()+;
        "teclea uno valido.","¡Error!")
        Frm_Warehouse.Txt_WarehouseName.SetFocus
        RETURN(.F.)
      ENDIF
    ENDIF

RETURN ( LbReturn )

RETURN
