#INCLUDE <hmg.ch>
#INCLUDE <PS_Posoft.ch>

PROCEDURE Functions
*------------------------------------------------------------------------------*
   FUNCTION ValorDeColumna( ControlName, ParentForm , nCol )
*------------------------------------------------------------------------------*
      LOCAL aRet := {}
      If GetControlType (ControlName,ParentForm) != "GRID"
         MSGINFO( "Objeto no esta en un Grid!!")
         RETURN( aRet )
      EndIf
      nCol := IIF( nCol == NIL .OR. nCol == 0 , 1 , nCol )
      aRet := GetProperty (  ParentForm  , ControlName , 'Item' ,;
      GetProperty( ParentForm , ControlName , 'Value' ) )
   RETURN( aRet[ nCol ] )

*------------------------------------------------------------------------------*
PROCEDURE PutMsg(PsMsg)
*------------------------------------------------------------------------------*
   CursorWait()
   WAIT WINDOW PsMsg NOWAIT
RETURN

*------------------------------------------------------------------------------*
PROCEDURE ClearMsg
*------------------------------------------------------------------------------*
   WAIT CLEAR
   CursorArrow()
RETURN	

*------------------------------------------------------------------------------*
FUNCTION ColumnGridValue( xObj, xForm, nCol)
*------------------------------------------------------------------------------*
   LOCAL nPos := GetProperty ( xForm , xObj , 'Value' )
   LOCAL aRet := GetProperty ( xForm , xObj , 'Item' , nPos )
RETURN aRet[nCol]

*------------------------------------------------------------------------------*
PROCEDURE ColorLostFocus()
*------------------------------------------------------------------------------*
   this.backcolor := {255, 255, 255}
Return Nil

*------------------------------------------------------------------------------*
PROCEDURE ColorGotFocus()
*------------------------------------------------------------------------------*
     this.backcolor := {211,237,250} //YELLOW
Return Nil

*------------------------------------------------------------------------------*
FUNCTION GetNextNumber(PsModule)
*------------------------------------------------------------------------------*
	LdDateSQL := "DATE('NOW')" 
	LsTimeSQL := "TIME('NOW','LOCALTIME')"
   LsModule := C2SQL(PsModule)
   GnNextNumber := 0
   IF .NOT. ConectMe()
      MsgExclamation ("No me pude conectar a la base de datos")
      RETURN NIL
   ELSE
      GsRead := "SELECT Module, Last_Number, "
      GsRead += "(Last_Number + Sequence_Count) AS [Next_Number] "
      GsRead += "FROM Folios WHERE LOWER(Module) = LOWER(&LsModule)"
//      IF TryToLock()
			aTableNextNum := sql(oDataBase,GsRead)
			GnNextNumber := aTableNextNum[1,3]
			GsQueryInsert := "UPDATE Folios SET "
         GsQueryInsert += "Last_Number = (Last_Number + Sequence_Count), "  
         GsQueryInsert += "Modify_Date = "+LdDateSQL +", "
         GsQueryInsert += "Modify_Time = "+LsTimeSQL       
			GsQueryInsert += "WHERE LOWER(Module) = LOWER(&LsModule)"
		   IF .NOT. BeforeSave(GsQueryInsert)
				MsgExclamation ("Error al tratar de obtener el folio siguiente.")
			ENDIF
//         DeleteFileLock()
//      ENDIF
   ENDIF
RETURN ( VAL(GnNextNumber ))

*------------------------------------------------------------------------------*
FUNCTION WichDate(PsKindeDate,PdDate)
*------------------------------------------------------------------------------*
   IF PdDate = NIL
      NewDate:="Sin fecha"
      RETURN(NewDate)
   ENDIF
   IF PsKindeDate=NIL
      PsKindeDate:="C"
   ENDIF
   DO CASE
      CASE PsKindeDate == "S"
         NewDate:= MonthName("S",MONTH(PdDate))+ALLTRIM(STR(DAY(PdDate)))+", "+ALLTRIM(STR(YEAR(PdDate)))
      CASE PsKindeDate == "L"
         NewDate:= MonthName("L",MONTH(PdDate))+ALLTRIM(STR(DAY(PdDate)))+", "+ALLTRIM(STR(YEAR(PdDate)))
      CASE PsKindeDate == "ML"
         NewDate:=  MonthName("L",MONTH(PdDate),PsKindeDate)
      CASE PsKindeDate == "MDAS"
         NewDate:= MonthName("S",MONTH(PdDate))+"/"+ALLTRIM(STR(DAY(PdDate)))+"/"+ALLTRIM(STR(YEAR(PdDate)))
      CASE PsKindeDate == "MDAL"
         NewDate:= MonthName("L",MONTH(PdDate))+" "+ALLTRIM(STR(DAY(PdDate)))+", "+ALLTRIM(STR(YEAR(PdDate)))
      CASE PsKindeDate == "DMAS"
         NewDate:= ALLTRIM(STR(DAY(PdDate)))+" "+MonthName("S",MONTH(PdDate))+" "+ALLTRIM(STR(YEAR(PdDate)))
      CASE PsKindeDate == "DMAL"
         NewDate:= ALLTRIM(STR(DAY(PdDate)))+"/"+MonthName("L",MONTH(PdDate))+"/"+ALLTRIM(STR(YEAR(PdDate)))
*      CASE PsKindeDate == "MDAL"
*         NewDate:= MonthName("L",MONTH(PdDate))+" "+ALLTRIM(STR(DAY(PdDate)))+" "+ALLTRIM(STR(YEAR(PdDate)))
      CASE PsKindeDate == "SQL"
         NewDate:= "'" + ALLTRIM(STR(YEAR(PdDate)))+;
                   IIF(MONTH(PdDate)<10,'0'+ALLTRIM(STR(MONTH(PdDate))),ALLTRIM(STR(MONTH(PdDate))))+;
                   IIF(DAY(PdDate)<10,'0'+ALLTRIM(STR(DAY(PdDate))),ALLTRIM(STR(DAY(PdDate)))) +"'"                  
      CASE PsKindeDate == "SQLAM"
         NewDate:= "'" + ALLTRIM(STR(YEAR(PdDate)))+;
                   IIF(MONTH(PdDate)<10,'0'+ALLTRIM(STR(MONTH(PdDate))),ALLTRIM(STR(MONTH(PdDate))))+;
                   IIF(DAY(PdDate)<10,'0'+ALLTRIM(STR(DAY(PdDate))),ALLTRIM(STR(DAY(PdDate)))) +" 00:00:00'"                     
      CASE PsKindeDate == "SQLPM"
         NewDate:= "'" + ALLTRIM(STR(YEAR(PdDate)))+;
                   IIF(MONTH(PdDate)<10,'0'+ALLTRIM(STR(MONTH(PdDate))),ALLTRIM(STR(MONTH(PdDate))))+;
                   IIF(DAY(PdDate)<10,'0'+ALLTRIM(STR(DAY(PdDate))),ALLTRIM(STR(DAY(PdDate)))) +" 23:59:00'"                       
      CASE PsKindeDate == 'MDB'
         NewDate := "'" + ALLTRIM ( STR( YEAR(PdDate))) + "-" +;
                   IIF(MONTH(PdDate)<10,'0'+ALLTRIM(STR(MONTH(PdDate))),ALLTRIM(STR(MONTH(PdDate))))+"-"+;
                   IIF(DAY(PdDate)<10,'0'+ALLTRIM(STR(DAY(PdDate))),ALLTRIM(STR(DAY(PdDate)))) +"'"
      CASE PsKindeDate == 'MDB#'
         NewDate := "#" + ALLTRIM ( STR( YEAR(PdDate))) + "-" +;
                   IIF(MONTH(PdDate)<10,'0'+ALLTRIM(STR(MONTH(PdDate))),ALLTRIM(STR(MONTH(PdDate))))+"-"+;
                   IIF(DAY(PdDate)<10,'0'+ALLTRIM(STR(DAY(PdDate))),ALLTRIM(STR(DAY(PdDate)))) +"#" 
      CASE PsKindeDate == "SQLite"
         NewDate:= "'" + ALLTRIM(STR(YEAR(PdDate)))+"-"+;
         IIF(MONTH(PdDate)<10,'0'+ALLTRIM(STR(MONTH(PdDate))),ALLTRIM(STR(MONTH(PdDate))))+"-"+;
         IIF(DAY(PdDate)<10,'0'+ALLTRIM(STR(DAY(PdDate))),ALLTRIM(STR(DAY(PdDate))))+"'" 

   ENDCASE
RETURN (NewDate)

*------------------------------------------------------------------------------*
FUNCTION MonthName(SwitchMes,WichMonth)
*------------------------------------------------------------------------------*
   DO CASE
      CASE UPPER(SwitchMes) = "L"
         aNomMes:= { "Enero ","Febrero ","Marzo ","Abril ","Mayo ","Junio ","Julio ","Agosto ","Septiembre ","Octubre ","Noviembre ","Diciembre " }
      CASE UPPER(SwitchMes) = "S"
         aNomMes := { "Ene.","Feb.","Mar.","Abr.","May.","Jun.","Jul.","Ago.","Sep.","Oct.","Nov.","Dic."}
   ENDCASE
RETURN (aNomMes[WichMonth])

*------------------------------------------------------------------------------*
PROCEDURE LoadMyData()
*------------------------------------------------------------------------------*
  GsPathDBName := GsRutaDB+"PoloPlast.db"
	IF ConectMe()
		GsReadQuery := "SELECT "
		GsReadQuery += "o.Name, "
		GsReadQuery += "o.Address_1, "
		GsReadQuery += "o.Address_2, "
		GsReadQuery += "o.Postal_Code, "
		GsReadQuery += "o.Code_Area, "
		GsReadQuery += "o.Phone_Office, "
		GsReadQuery += "IFNULL(o.Fiscal_Id,''), "
		GsReadQuery += "o.E_mail, "
		GsReadQuery += "o.URL, "
		GsReadQuery += "o.LOGO_Owner, "
		GsReadQuery += "IFNULL(s.Name,''), "
		GsReadQuery += "IFNULL(c.Name,''), "
		GsReadQuery += "IFNULL(o.Sales_Serie,''), "
      GsReadQuery += "IFNULL(o.Global_Tax_Percen, 0) "      
		GsReadQuery += "FROM Owner AS o "
		GsReadQuery += "LEFT JOIN STATES AS s ON o.State_Id = s.State_Id "
		GsReadQuery += "LEFT JOIN CITIES AS c ON o.City_Id = c.City_Id"
		//      aTableOwner := ReadData (GsReadQuery)
		aGetOwnerData := ReadData (GsReadQuery)
			IF LEN (aGetOwnerData) = 0
			GbIsNew := .T.
			MsgExclamation ("No existe datos de la empresa, eso puede casuar errores.","Capture los datos.")
	ELSE
			GsMyName     := ALLTRIM (aGetOwnerData[1,1])
			GsMyAddress1 := ALLTRIM (aGetOwnerData[1,2])
			GsMyAddress2 := ALLTRIM (aGetOwnerData[1,3])
			GsMyZipCode := ALLTRIM (aGetOwnerData[1,4])
			GsMyAreaCode  := ALLTRIM (aGetOwnerData[1,5])
			GsMyPhone := ALLTRIM (aGetOwnerData[1,6])
			GsMyFiscalData    := ALLTRIM (aGetOwnerData[1,7])
			GsMyEmail := ALLTRIM (aGetOwnerData[1,8])
			GsMyURL:= ALLTRIM (aGetOwnerData[1,9])
			GsMyLogo:= ALLTRIM (aGetOwnerData[1,10])
			GsMyStateName:= ALLTRIM (aGetOwnerData[1,11])
			GsMyCityName := ALLTRIM (aGetOwnerData[1,12])
			GsMySalesSerie := ALLTRIM (aGetOwnerData[1,13])
			GnGlobalTaxPercen := ALLTRIM (aGetOwnerData[1,14])
			ENDIF
		   
	EndIf
RETURN

*------------------------------------------------------------------------------*            
FUNCTION FindStates
*------------------------------------------------------------------------------*
   GsStateName := ""
   GnStateId := 0
   GsCityName := ""
   GnCityId := 0  
   ShowStates()
RETURN  (Nil)

*------------------------------------------------------------------------------*
FUNCTION FindCities
*------------------------------------------------------------------------------*
   GsCityName := ""
   GnCityId := 0
   ShowCities()
RETURN  (Nil)

*------------------------------------------------------------------------------*
PROCEDURE GetSqlVersion
*------------------------------------------------------------------------------*
  GsReadQuery := "select sqlite_version() "
  	IF TryToLock()
	   aGetTableData := ReadData (GsReadQuery)
	   DeleteFileLock()
	ENDIF
  MsgStop(ALLTRIM(aGetTableData[i,1]), aGetTableData[i,1])
RETURN

*------------------------------------------------------------------------------*
FUNCTION My_WoY( dDate )
*------------------------------------------------------------------------------*
LOCAL nDays, nWeek, dDoY
If hb_IsDate( dDate )
   dDoY := hb_Date( Year( dDate ), 1, 1 )
   nDays := 1 + ( dDate - dDoY ) - ( 8 - DoW( dDoY ) )
   nWeek := 1
   DO WHILE nDays > 0
      ++nWeek
      nDays -= 7
   ENDDO
   RETURN nWeek
ENDIF
RETURN NIL
