#INCLUDE <hmg.ch>
#INCLUDE <PS_Posoft.ch>

PROCEDURE InsertCountries
   LnRecordCount:=0
   LnRecordCounter:=0
   DBUSEAREA(.T.,"DBFCDX",GsRutaDB+"Countries", "Countries", GbShared, GbWrite)
   LnRecordCount := Countries->(LASTREC())

   DO WHILE !Countries->(EOF())
      LsProgName = "'" + PROCNAME() + "'"
      GdDateSQL := "DATE('NOW')" 
      GsTimeSQL := "TIME('NOW','LOCALTIME')"
      LnRecordCounter++
         LsCountryId := C2SQL( ALLTRIM  ( UPPER (Countries->COUNTRY_CD )))
         LsCountryName := C2SQL( ALLTRIM  ( UPPER (Countries->COUNT_NAME )))
         GsQueryInsert := "INSERT INTO Countries ("
         GsQueryInsert += "Country_Id, "
         GsQueryInsert += "COUNTRY_CD, "
         GsQueryInsert += "Name,  "
         GsQueryInsert += "Is_Visible, "
         GsQueryInsert += "Sys_User_Id, "
         GsQueryInsert += "Entry_Date, "
         GsQueryInsert += "Entry_Time, "
         GsQueryInsert += "Prog_Name) "
         GsQueryInsert += "VALUES ("+C2SQL(GetNextNumber("country_id"))+", "
         GsQueryInsert += C2SQL( ALLTRIM  ( UPPER (Countries->COUNTRY_CD )))+", "
         GsQueryInsert += C2SQL( ALLTRIM  ( UPPER (Countries->COUNT_NAME )))+", "
         GsQueryInsert += C2SQL( Countries->IS_VISIBLE )+", "         
         GsQueryInsert += "&GsSystemUser"+ ", "
         GsQueryInsert += GdDateSQL+", "
         GsQueryInsert += GsTimeSQL+", "
         GsQueryInsert += "&LsProgName )"         
            IF .NOT. ExistsDataInDB("Countries", "WHERE COUNTRY_CD = &LsCountryId")
               IF BeforeSave(GsQueryInsert)
                  PutMsg ("Pais ..."+ALLTRIM(Countries->COUNT_NAME)+" "+ALLTRIM(STR(LnRecordCounter))+"/"+ALLTRIM(STR(LnRecordCount))  )
               ELSE
                  MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato o de acceso a la base de datos.")
               ENDIF
            ENDIF
      Countries->( DBSKIP ())
   ENDDO
   ClearMsg()
   Countries->(DBCLOSEAREA())
   MsgInfo("Fin de insertar PAISES")
RETURN

PROCEDURE InsertStates
   LnRecordCount:=0
   LnRecordCounter:=0
   LsProgName = C2SQL(PROCNAME())
   GdDateSQL := "DATE('NOW')" 
   GsTimeSQL := "TIME('NOW','LOCALTIME')"
   
   DBUSEAREA(.T.,"DBFCDX",GsRutaDB+"States", "States", GbShared, GbWrite)
   LnRecordCount := States->(LASTREC())
   DO WHILE !States->(EOF())
      // IF UPPER ( ALLTRIM (Estados->COUNTRY_CD)) = "MX"
      LsCountryId := C2SQL( ALLTRIM  ( UPPER (States->COUNTRY_CD )))
      LsStateId := C2SQL( ALLTRIM  ( UPPER (States->State_Cd )))
      LsStateName := C2SQL( ALLTRIM  ( UPPER (States->State_Name )))
      LnRecordCounter++
      GsQueryInsert := "INSERT INTO States ("
      GsQueryInsert += "STATE_Id, "
      GsQueryInsert += "Country_Cd, "
      GsQueryInsert += "State_Cd, "
      GsQueryInsert += "Name, "
      GsQueryInsert += "Is_Visible, "
      GsQueryInsert += "Sys_User_Id, "
      GsQueryInsert += "Entry_Date, "
      GsQueryInsert += "Entry_Time, "
      GsQueryInsert += "PROG_NAME) "
      GsQueryInsert += "VALUES ("+C2SQL(GetNextNumber("state_id"))+", "
      GsQueryInsert += C2SQL( ALLTRIM  ( UPPER (States->COUNTRY_CD )))+", "
      GsQueryInsert += C2SQL( ALLTRIM  ( UPPER (States->State_Cd )))+", "         
      GsQueryInsert += C2SQL( ALLTRIM  ( UPPER (States->STATE_NAME )))+", "
      GsQueryInsert += C2SQL( States->IS_VISIBLE )+ ", "
      GsQueryInsert += "&GsSystemUser ,"
      GsQueryInsert += GdDateSQL+", "
      GsQueryInsert += GsTimeSQL+", "
      GsQueryInsert += "&LsProgName )"
        
         IF .NOT. ExistsDataInDB("States", "WHERE STATE_CD = &LsStateId AND Country_Cd = &LsCountryId")
            IF BeforeSave(GsQueryInsert)
                PutMsg ("Estado ..."+ALLTRIM(States->STATE_NAME)+" "+ALLTRIM(STR(LnRecordCounter))+"/"+ALLTRIM(STR(LnRecordCount)))
            ELSE
               MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato o de acceso a la base de datos.")
            ENDIF
			ENDIF
      States->( DBSKIP ())
   ENDDO
   ClearMsg()
   States->(DBCLOSEAREA())
   GsQueryInsert := "UPDATE STATES SET Country_Id = (SELECT Country_Id FROM COUNTRIES "
	GsQueryInsert += "WHERE COUNTRIES.Country_Cd = STATES.Country_Cd)"
   IF .NOT. BeforeSave(GsQueryInsert)
      MsgInfo("No se actualizo las tablas en SQLite")
   ENDIF											
   MsgInfo("Fin de insertar ESTADOS")
RETURN

PROCEDURE InsertCities
   LnRecordCount:=0
   LnRecordCounter:=0
   LsProgName = C2SQL(PROCNAME())
   GdDateSQL := "DATE('NOW')" 
   GsTimeSQL := "TIME('NOW','LOCALTIME')"
   
   DBUSEAREA(.T.,"DBFCDX",GsRutaDB+"Cities", "Cities", GbShared, GbWrite)
   LnRecordCount := Cities->(LASTREC())

   DO WHILE !Cities->(EOF())
     // IF UPPER ( ALLTRIM (Cities->Country_Cd)) = "MX"
         LsCountryId := C2SQL( ALLTRIM ( UPPER (Cities->Country_Cd )))
         LsStateId := C2SQL( ALLTRIM ( UPPER (Cities->State_Cd )))
         LsCityName := C2SQL( ALLTRIM ( UPPER (Cities->City_Name )))
         SQLDate := C2SQL( DATE() )
         LtTime := C2SQL( TIME() )
         LnRecordCounter++
         GsQueryInsert := "INSERT INTO Cities ("
         GsQueryInsert += "City_Id, "
         GsQueryInsert += "Country_Cd, "
         GsQueryInsert += "State_Cd, "
         GsQueryInsert += "Name, "
         GsQueryInsert += "Is_Visible, "
         GsQueryInsert += "Sys_User_Id, "
         GsQueryInsert += "Entry_Date, "
         GsQueryInsert += "Entry_Time, "
         GsQueryInsert += "Prog_Name) "       
         GsQueryInsert += "VALUES ("+C2SQL(GetNextNumber("city_id"))+", "
         GsQueryInsert += C2SQL( ALLTRIM ( UPPER (Cities->Country_Cd )))+", "
         GsQueryInsert += C2SQL( ALLTRIM ( UPPER (Cities->State_Cd )))+", "
         GsQueryInsert += C2SQL( ALLTRIM ( UPPER (Cities->City_Name )))+", "
         GsQueryInsert += C2SQL( Cities->IS_VISIBLE )+ ", "
         GsQueryInsert += "&GsSystemUser ,"
         GsQueryInsert += GdDateSQL+", "
         GsQueryInsert += GsTimeSQL+", "
         GsQueryInsert += "&LsProgName ) "

         //IF .NOT. connect2db(cDBName,.T.)
            IF .NOT. ExistsDataInDB("Cities", "WHERE State_Cd = &LsStateId AND Name = &LsCityName and Country_Cd = &LsCountryId")
               IF BeforeSave(GsQueryInsert)
                  PutMsg ("Ciudad ...    "+ALLTRIM(Cities->City_Name)+"  "+ALLTRIM(STR(LnRecordCounter))+"/"+ALLTRIM(STR(LnRecordCount)))
               ELSE
                  MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato o de acceso a la base de datos.")
               ENDIF
            ENDIF
      //ENDIF
      Cities->( DBSKIP ())
   ENDDO
   ClearMsg()
   Cities->(DBCLOSEAREA())
      GsQueryInsert := "UPDATE CITIES SET Country_Id = (SELECT Country_Id FROM STATES "
      GsQueryInsert += "WHERE CITIES.Country_Cd = STATES.Country_Cd)"
               IF BeforeSave(GsQueryInsert)
                  MsgInfo("No se hizo la actualización algo raro paso en el UPDATE")
               ENDIF
      GsQueryInsert := "UPDATE CITIES SET State_Id = (SELECT State_Id FROM STATES WHERE "
      GsQueryInsert += "CITIES.Country_Cd = STATES.Country_Cd AND "
      GsQueryInsert += "CITIES.State_Cd = STATES.State_Cd)"
               IF BeforeSave(GsQueryInsert)
                  MsgInfo("No se hizo la actualización algo raro paso en el UPDATE")
               ENDIF
   MsgInfo ("Se terminó de insertar las ciudades")
   
RETURN

PROCEDURE InsertCurrencies
   LsProgName = C2SQL(PROCNAME())
   LnCurrencyId := 0
   GdDateSQL := "DATE('NOW')" 
   GsTimeSQL := "TIME('NOW','LOCALTIME')"
                    
   LnCurrencyId := C2SQL(GetNextNumber("currency_id")) 
    GsQueryInsert := "INSERT INTO Currencies (Country_Id, Currency_Id, Currency_Cd, Name, Symbol, IS_VISIBLE,Sys_User_Id, Entry_Date, Entry_Time, Prog_Name) "
    GsQueryInsert += "VALUES (55 , &LnCurrencyId, 'MXP', 'Peso', '$', 1, &GsSystemUser, &GdDateSQL, &GsTimeSQL, &LsProgName ) "
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgInfo("No se insert en CURRENCIES MXP")
    ENDIF    

   LnCurrencyId := C2SQL(GetNextNumber("currency_id"))
    GsQueryInsert := "INSERT INTO Currencies (Country_Id, Currency_Id, Currency_Cd, Name, Symbol, IS_VISIBLE,Sys_User_Id, Entry_Date, Entry_Time, Prog_Name) "
    GsQueryInsert += "VALUES (85 ,  &LnCurrencyId, 'USD', 'Dolar americano', 'usd', 1, &GsSystemUser, &GdDateSQL, &GsTimeSQL, &LsProgName ) "
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgInfo("No se insert en CURRENCIES USD")
    ENDIF    
    
    LnCurrencyId := C2SQL(GetNextNumber("currency_id"))
    GsQueryInsert := "INSERT INTO Currencies (Country_Id, Currency_Id, Currency_Cd, Name, Symbol, IS_VISIBLE,Sys_User_Id, Entry_Date, Entry_Time, Prog_Name) "
    GsQueryInsert += "VALUES (11 ,  &LnCurrencyId, 'USC', 'Dolar canadiense', 'usc', 1, &GsSystemUser, &GdDateSQL, &GsTimeSQL, &LsProgName ) "
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgInfo("No se insert en CURRENCIES USC")
    ENDIF    

    LnCurrencyId := C2SQL(GetNextNumber("currency_id"))
    GsQueryInsert := "INSERT INTO Currencies (Country_Id, Currency_Id, Currency_Cd, Name, Symbol, IS_VISIBLE,Sys_User_Id, Entry_Date, Entry_Time, Prog_Name) "
    GsQueryInsert += "VALUES (0 ,  &LnCurrencyId, 'EUR', 'Euro', '€', 1, &GsSystemUser, &GdDateSQL, &GsTimeSQL, &LsProgName ) "
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgInfo("No se insert en CURRENCIES EUR")
    ENDIF    
   MsgInfo("Fin de insertar MONEDAS")
RETURN

// *****************************************************************************
PROCEDURE InsertGroup 
   LnRecordCount:=0
   LnRecordCounter:=0
   LsGpoName := ""
   LsProgName = C2SQL(PROCNAME())
   SQLDate := C2SQL( DATE() )
   LtTime := C2SQL( TIME() )
                                                     
   GsQueryInsert := "INSERT INTO Item_Group (Group_Id, Name, Is_Visible, Sys_User_Id, Entry_Date,Entry_Time,Prog_Name) "
   GsQueryInsert += " VALUES (0, 'Sin Asignar',1,&GsSystemUser,&SQLDate,&LtTime,&LsProgName)"
   IF .NOT. BeforeSave(GsQueryInsert)
    Msgexclamation ("Error al insertar el registro CERO")
   ENDIF
     
   DBUSEAREA(.T.,"DBFCDX",GsRutaDB+"Items", "Items", GbShared, GbWrite)
   LnRecordCount := Items->(LASTREC())

   DO WHILE !Items->(EOF())
      LsGpoName := "'"+ ALLTRIM ( UPPER (Items->GpoName )) + "'"
      SQLDate := C2SQL( DATE() )
      LtTime := C2SQL( TIME() )
      IF Items->GpoName = "                                         "  
        DBSKIP()
        LOOP
      ENDIF
      IF .NOT. ExistsDataInDB("Item_Group", "WHERE Name = &LsGpoName")
        LnRecordCounter++
        LnGroupId := C2SQL (GetNextNumber("group_Id"))
        GsQueryInsert := "INSERT INTO Item_Group ("
        GsQueryInsert += "Group_Id, "
        GsQueryInsert += "Name, " 
        GsQueryInsert += "Is_Visible, "
        GsQueryInsert += "Sys_User_Id, "
        GsQueryInsert += "Entry_Date, "
        GsQueryInsert += "Entry_Time, "
        GsQueryInsert += "Prog_Name) "
        GsQueryInsert += "VALUES ("
        GsQueryInsert += LnGroupId+", "  
        GsQueryInsert += LsGpoName+", " 
        GsQueryInsert += C2SQL(1)+", "
        GsQueryInsert += "&GsSystemUser ,"
        GsQueryInsert += SQLDate+", "
        GsQueryInsert += LtTime+", "
        GsQueryInsert += "&LsProgName ) "   
        IF BeforeSave(GsQueryInsert)
          PutMsg ("Grupo ...    "+ALLTRIM(Items->GpoName)+"  "+ALLTRIM(STR(LnRecordCounter))+"/"+ALLTRIM(STR(LnRecordCount)))
        ELSE
          MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato o de acceso a la base de datos.")
        ENDIF
      ENDIF
    DBSKIP ()   
   ENDDO
   DBCLOSEALL()
   ClearMsg()
   MsgInfo("Fin de insertar grupos de articulos")
RETURN

// *****************************************************************************
PROCEDURE InsertSubGroup 
   LnRecordCount:=0
   LnRecordCounter:=0
   LsGpoName := ""
   LsProgName = C2SQL(PROCNAME())
   SQLDate := C2SQL( DATE() )
   LtTime := C2SQL( TIME() )     
                                                        
    GsQueryInsert := "INSERT INTO Item_Sub_Group (Sub_Group_Id, "
    GsQueryInsert += "Name, Is_Visible, Prog_Name, "
    GsQueryInsert += "Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (" 
    GsQueryInsert += C2SQL(0)+", "                                      
    GsQueryInsert += C2SQL("Sin asignar")+", "
    GsQueryInsert += C2SQL(1)+", "
    GsQueryInsert += "&GsSystemUser,&SQLDate,&LtTime,&LsProgName)" 
   
   IF .NOT. BeforeSave(GsQueryInsert)
    Msgexclamation ("Error al insertar el registro CERO")
   ENDIF
// *****************************************************************************
   
PROCEDURE InsertItem
   LnRecordCount:=0
   LnRecordCounter:=0
   LsProgName = C2SQL(PROCNAME())
   
   DBUSEAREA(.T.,"DBFCDX",GsRutaDB+"Items", "Items", GbShared, GbWrite)
   LnRecordCount := Items->(LASTREC())

   DO WHILE !Items->(EOF())
         LsItemCd := C2SQL( ALLTRIM ( UPPER (Items->Item_Cd )))
         LsDescr := "'"+ ALLTRIM ( UPPER (Items->Desc )) + "'"  
         LsUnidBase := "'"+ ALLTRIM ( UPPER (Items->UnidBase )) + "'"
         SQLDate := C2SQL( DATE() )
         LtTime := C2SQL( TIME() )
         LnRecordCounter++
         GsQueryInsert := "INSERT INTO Item ("
         GsQueryInsert += "Item_Cd, "
         GsQueryInsert += "Name, "
         GsQueryInsert += "Group_Id, "
         GsQueryInsert += "Sub_Group_Id, "
         GsQueryInsert += "Unit_Measure_Base, "   
         GsQueryInsert += "Picture_Path, "
         GsQueryInsert += "Is_Visible, "
         GsQueryInsert += "Sys_User_Id, "
         GsQueryInsert += "Entry_Date, "
         GsQueryInsert += "Entry_Time, "
         GsQueryInsert += "Prog_Name, "
         GsQueryInsert += "Accounting_Num, "
         GsQueryInsert += "Using_For, "
         GsQueryInsert += "Warehouse_Place, "
         GsQueryInsert += "Group_Name) "
         GsQueryInsert += "VALUES ("+C2SQL( ALLTRIM ( UPPER (Items->Item_Cd )))+", "
         GsQueryInsert += LsDescr+", "  
         GsQueryInsert += C2SQL(0)+", "
         GsQueryInsert += C2SQL(0)+", " 
         GsQueryInsert += C2SQL(ALLTRIM(Items->UnidBase))+", " 
         GsQueryInsert += C2SQL("")+", "         
         GsQueryInsert += C2SQL( 1)+ ", "
         GsQueryInsert += "&GsSystemUser ,"
         GsQueryInsert += SQLDate+", "
         GsQueryInsert += LtTime+", "
         GsQueryInsert += "&LsProgName, " 
         GsQueryInsert += C2SQL(ALLTRIM(items->CtaCont))+", "
         GsQueryInsert += C2SQL(ALLTRIM(Items->Se_Utiliza))+", "
         GsQueryInsert += C2SQL(ALLTRIM(Items->Ubicacion))+", "         
         GsQueryInsert += C2SQL(ALLTRIM(UPPER(Items->GpoName)))+") "
//inputbox("","",GsQueryInsert)
            IF .NOT. ExistsDataInDB("Item", "WHERE Item_Cd = &LsItemCd")
               IF BeforeSave(GsQueryInsert)
                  PutMsg ("Articulo ...    "+ALLTRIM(Items->Item_Cd)+"  "+ALLTRIM(STR(LnRecordCounter))+"/"+ALLTRIM(STR(LnRecordCount)))
               ELSE
                  MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato o de acceso a la base de datos.")
               ENDIF
            ENDIF
      DBSKIP ()
   ENDDO
   ClearMsg()
   DBCLOSEAREA() 
   
   PutMsg ("Actualizando tabla de Articulo ...")
    GsQueryInsert := "UPDATE Item SET Group_id = (select g.Group_id FROM Item_Group g where g.Name = item.Group_Name)"
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato o de acceso a la base de datos.")
    ENDIF
   ClearMsg()
   MsgInfo ("Se terminó de insertar los articulos y actualizarlos")  
RETURN
// *****************************************************************************
// Proveedores 
PROCEDURE InsertProviders 
   LnRecordCount:=0
   LnRecordCounter:=0
   LsProgName = C2SQL(PROCNAME())
   GdDateSQL := "DATE('NOW')" 
   GsTimeSQL := "TIME('NOW','LOCALTIME')"
   
   DBUSEAREA(.T.,"DBFCDX",GsRutaDB+"Provider", "Provider", GbShared, GbWrite)
   LnRecordCount := Provider->(LASTREC())

   DO WHILE !Provider->(EOF())
         LsDescr := "'"+ ALLTRIM ( UPPER (Provider->provider )) + "'"
         SQLDate := C2SQL( DATE() )
         LtTime := C2SQL( TIME() )
         LnRecordCounter++
         GsQueryInsert := "INSERT INTO Provider ("
         GsQueryInsert += "Provider_Id, "
         GsQueryInsert += "Name, "
          GsQueryInsert += "Standard_Status_Id, "           
         GsQueryInsert += "Is_Visible, "
         GsQueryInsert += "Sys_User_Id, "
         GsQueryInsert += "Entry_Date, "
         GsQueryInsert += "Entry_Time, "
         GsQueryInsert += "Prog_Name) "
         GsQueryInsert += "VALUES ("+C2SQL(GetNextNumber("provider_Id"))+", "       
         GsQueryInsert += LsDescr+", "  
         GsQueryInsert += C2SQL(1)+", "
         GsQueryInsert += C2SQL(1)+", "
         GsQueryInsert += "&GsSystemUser ,"
         GsQueryInsert += GdDateSQL+", "
         GsQueryInsert += GsTimeSQL+", "
         GsQueryInsert += "&LsProgName ) "

        IF .NOT. ExistsDataInDB("Provider", "WHERE Name = &LsDescr")
           IF BeforeSave(GsQueryInsert)
              PutMsg ("Proveedor ...    "+ALLTRIM(Provider->provider)+"  "+ALLTRIM(STR(LnRecordCounter))+"/"+ALLTRIM(STR(LnRecordCount)))
           ELSE
              MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato o de acceso a la base de datos.")
           ENDIF
        ENDIF
      DBSKIP ()
   ENDDO
   ClearMsg()
   DBCLOSEAREA()
      
   MsgInfo ("Se terminó de insertar los Proveedores")
      
// Segunda parte que es de insertar los articulo a cada proveedor. 
    PutMsg ("Espere... insertando articulos a cada proveedor, esto puede tomar un poco de tiempo")
    SQLDate := C2SQL( DATE() )
    LtTime := C2SQL( TIME() )   
    GsQueryInsert := "INSERT INTO item_Provider (Provider_id, Item_cd, Cost, Tax_Percentage, "
    GsQueryInsert += "Is_Visible, Sys_User_Id, Entry_Date, Entry_Time, Prog_Name) "
    GsQueryInsert += "SELECT p.Provider_id, i.Item_cd, ROUND(i.ps_id*35.92,2), 16,1, &GsSystemUser, "
    GsQueryInsert += GdDateSQL+", "
    GsQueryInsert += GsTimeSQL+", "
    GsQueryInsert += "&LsProgName FROM item i, Provider p "
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al insertar los articulos a proveedores." , "ERROR")
    ELSE
      ClearMsg()
      MsgInfo ("Se terminó de insertar los articulos a todos los proveedores.")
    ENDIF 
RETURN
// *****************************************************************************

PROCEDURE InsertFolios
// Contador de Folios
    PutMsg("Insertando folios")
   LsProgName = C2SQL(PROCNAME())
   GdDateSQL := "DATE('NOW')" 
   GsTimeSQL := "TIME('NOW','LOCALTIME')"
   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('sys_user_id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"   
   IF TryToLock()
     IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'sys_user_id'")
        IF .NOT. BeforeSave(GsQueryInsert)
           MsgExclamation ("Error al tratar de insertar el folio sys_user_id.")
        ENDIF
     ENDIF
     DeleteFileLock()
   ENDIF
   
   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('customer_id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
      IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'customer_id'")
      IF .NOT. BeforeSave(GsQueryInsert)
         MsgExclamation ("Error al tratar de insertar el folio customer_id")
    ENDIF 
    endif
     DeleteFileLock()
   ENDIF        
    
   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('country_id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'country_id'")
        IF .NOT. BeforeSave(GsQueryInsert)
           MsgExclamation ("Error al tratar de insertar el folio country_id.")
        ENDIF
     ENDIF
     DeleteFileLock()
   ENDIF   
   
   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('state_id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'state_id'")
        IF .NOT. BeforeSave(GsQueryInsert)
           MsgExclamation ("Error al tratar de insertar el folio state_id.")
        ENDIF
     ENDIF
     DeleteFileLock()
   ENDIF   

   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('city_id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'city_id'")
        IF .NOT. BeforeSave(GsQueryInsert)
           MsgExclamation ("Error al tratar de insertar el folio city_id.")
        ENDIF
     ENDIF
     DeleteFileLock()
   ENDIF   
 
   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('currency_id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'currency_id'")
        IF .NOT. BeforeSave(GsQueryInsert)
           MsgExclamation ("Error al tratar de insertar el folio currency_id.")
        ENDIF
     ENDIF
     DeleteFileLock()
   ENDIF    
     
   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('payment_id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'payment_id'")
        IF .NOT. BeforeSave(GsQueryInsert)
           MsgExclamation ("Error al tratar de insertar el folio payment_id.")
        ENDIF
     ENDIF
     DeleteFileLock()
   ENDIF   

   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('tec_support_id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'tec_support_id'")
        IF .NOT. BeforeSave(GsQueryInsert)
           MsgExclamation ("Error al tratar de insertar el folio tec_support_id.")
        ENDIF
     ENDIF
     DeleteFileLock()
   ENDIF   
       
   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('purchase_id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'purchase_id'")
        IF .NOT. BeforeSave(GsQueryInsert)
           MsgExclamation ("Error al tratar de insertar el folio Purchase.")
        ENDIF
     ENDIF
     DeleteFileLock()
   ENDIF 

   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('provider_id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'provider_id'")
        IF .NOT. BeforeSave(GsQueryInsert)
           MsgExclamation ("Error al tratar de insertar el folio Provider.")
        ENDIF
     ENDIF
     DeleteFileLock()
   ENDIF 
   
   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('Group_Id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'Group_Id'")
        IF .NOT. BeforeSave(GsQueryInsert)
           MsgExclamation ("Error al tratar de insertar el folio Provider.")
        ENDIF
     ENDIF
     DeleteFileLock()
   ENDIF                             
   
   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('kardex_id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'kardex_id'")
        IF .NOT. BeforeSave(GsQueryInsert)
           MsgExclamation ("Error al tratar de insertar el folio Provider.")
        ENDIF
     ENDIF
     DeleteFileLock()
   ENDIF   
   
   GsQueryInsert := "INSERT INTO Folios ("
   GsQueryInsert += "Module, Last_Number, Sequence_Count, "
   GsQueryInsert += "Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
   GsQueryInsert += "VALUES ('warehouse_id', 0, 1, &LsProgName, &GsSystemUser, "
   GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. ExistsDataInDB("Folios", "WHERE Module = 'warehouse_id'")
        IF .NOT. BeforeSave(GsQueryInsert)
           MsgExclamation ("Error al tratar de insertar el folio warehouse_id")
        ENDIF
     ENDIF
     DeleteFileLock()
   ENDIF
   
// Standard_Status
    PutMsg("Insertando estatus estándares")    
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (0, 1, 'Sin definir', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  
                                                                         
    GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (1, 1, 'Activo', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (100, 1, 'Suspencion temporal', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF                

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (101, 1, 'Inactivo', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  
      
// SUPPORT 
//  Ingenieros de soporte 
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (0, 2, 'Sin definir', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  
                                                                         
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (1, 2, 'Activo', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (100, 2, 'Suspencion temporal', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF
                         
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (101, 2, 'Inactivo', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  
 

// CUSTOMER 
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (0, 3, 'Sin definir', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  
                                                                         
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (1, 3, 'Activo', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (100, 3, 'Suspencion temporal', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF                          
       
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (101, 3, 'Inactivo', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  
                            
// ITEMS 
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (0, 4, 'Sin definir', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  
                                                                         
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (1, 4, 'Activo', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (100, 4, 'Suspencion temporal', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (101, 4, 'Inactivo', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF                          

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (102, 4, 'Baja definitiva', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF                          

// EQUIPMENT 
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (0, 5, 'Sin definir', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  
                                                                         
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (1, 5, 'Activo', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (2, 5, 'En aduana', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (100, 5, 'Suspencion temporal', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF                          

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (101, 5, 'Inactivo', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF  
    
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (102, 5, 'Baja definitiva', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
    ENDIF                          
   
// PURCHASE         
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (1, 6,'Creada enviada proveedor.', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
    DeleteFileLock()
  ENDIF

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (2, 6,'Recibida pendiente de inventario', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
    DeleteFileLock()
  ENDIF

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (3, 6,'Entrada inventario', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
    DeleteFileLock()
  ENDIF

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (4, 6,'Pendiente de pago', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
    DeleteFileLock()
  ENDIF

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (5, 6,'Pagada', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
    DeleteFileLock()
  ENDIF
            
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (100, 6, 'Cancelada', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
  ENDIF   

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (101, 6, 'Rechazada', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
  ENDIF
     
    
// INCIDENT         
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (0, 7, 'Sin definir', 1,'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()         
  ENDIF
          
     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (1, 7, 'Entrada por compra', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
  ENDIF

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (2, 7, 'Entrada por devolucion', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
  ENDIF   

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (3, 7, 'Entrada por defecto', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
  ENDIF   

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (100, 7, 'Salida por venta', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
  ENDIF   

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (101, 7, 'Salida por cambio', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
  ENDIF   

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (102, 7, 'Salida por remplazo', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
  ENDIF   

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (103, 7, 'Salida por exhibicion', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
  ENDIF   

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (104, 7, 'Salida por obsequio', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
  ENDIF   

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (105, 7, 'Salida por merma', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()     
  ENDIF              

     GsQueryInsert := "INSERT INTO Standard_Status (Standard_Status_Id, Module_Id, "
     GsQueryInsert += "Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
     GsQueryInsert += "VALUES (106, 7, 'Salida por robo', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
  ENDIF
    
// Inserta los modulos de la aplicacion 
      GsQueryInsert := "INSERT INTO Modules (Module_Id, Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
      GsQueryInsert += "VALUES (1, 'company', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
      IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
       ENDIF
       DeleteFileLock()
    ENDIF

      GsQueryInsert := "INSERT INTO Modules (Module_Id, Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
      GsQueryInsert += "VALUES (2, 'support', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
      IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
       ENDIF
       DeleteFileLock()
    ENDIF

      GsQueryInsert := "INSERT INTO Modules (Module_Id, Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
      GsQueryInsert += "VALUES (3, 'customer', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
      IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
       ENDIF
       DeleteFileLock()
    ENDIF

      GsQueryInsert := "INSERT INTO Modules (Module_Id, Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
      GsQueryInsert += "VALUES (4, 'items', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
      IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
       ENDIF
       DeleteFileLock()
    ENDIF

      GsQueryInsert := "INSERT INTO Modules (Module_Id, Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
      GsQueryInsert += "VALUES (5, 'equipment', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
      IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
       ENDIF
       DeleteFileLock()
    ENDIF

      GsQueryInsert := "INSERT INTO Modules (Module_Id, Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
      GsQueryInsert += "VALUES (6, 'purchase', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
      IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
       ENDIF
       DeleteFileLock()
    ENDIF

      GsQueryInsert := "INSERT INTO Modules (Module_Id, Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
      GsQueryInsert += "VALUES (7, 'stock', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
      IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
       ENDIF
       DeleteFileLock()
    ENDIF

      GsQueryInsert := "INSERT INTO Modules (Module_Id, Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
      GsQueryInsert += "VALUES (8, 'actiontracking', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
    IF TryToLock()
      IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
       ENDIF
       DeleteFileLock()
    ENDIF

        
// Insertando Tipo de compra    
      GsQueryInsert := "INSERT INTO Purchase_Type (Purchase_Type_Id, Name, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
      GsQueryInsert += "VALUES (1, 'Compra', 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
  ENDIF

    
// Insertando TMensajes de error de la aplicacon
      PutMsg("Insertando Mensajes de error")
      GsQueryInsert := "INSERT INTO Messenger_Error (Error_Id, Msg_Type, Error_Description, "
      GsQueryInsert += "Language_Id,Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, "
      GsQueryInsert += "Entry_Time) VALUES (0, 'MsgInfo', 'No mensaje', 'MX', 1, " 
      GsQueryInsert += "'Manual', 'sa', "
      GsQueryInsert += "&GdDateSQL, &GsTimeSQL)"
IF TryToLock()
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF
     DeleteFileLock()
ENDIF
    
      GsQueryInsert := "INSERT INTO Messenger_Error (Error_Id, Msg_Type, Error_Description, "
      GsQueryInsert += "Language_Id, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, "
      GsQueryInsert += "Entry_Time) VALUES (1, 'MsgExclamation', "
      GsQueryInsert += "'No Ya existe ese cliente', "
      GsQueryInsert += "'MX', 1, 'Manual', 'sa', &GdDateSQL, &GsTimeSQL)"
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF
  
// Pay_Methods
    PutMsg("Insertando métodos de pago")
    GsQueryInsert := "INSERT INTO Pay_Method (Pay_Method_Id, Name, Prefix, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) " +;
            "VALUES (1, 'Tarjeta de credito', 'tc', 1, 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
  IF TryToLock()            
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar Tarjeta de credito.")
     ENDIF    
    DeleteFileLock()
  ENDIF
    GsQueryInsert := "INSERT INTO Pay_Method (Pay_Method_Id, Name, Prefix, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) " +;
        "VALUES (2, 'Tarjeta de debito', 'td', 1, 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar Tarjeta de debito.")
     ENDIF
     DeleteFileLock()
   ENDIF

    GsQueryInsert := "INSERT INTO Pay_Method (Pay_Method_Id, Name, Prefix, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) " +;
            "VALUES (3, 'Cheque', 'chq', 1, 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar Cheque")
     ENDIF
     DeleteFileLock()
   ENDIF
       
    
    GsQueryInsert := "INSERT INTO Pay_Method (Pay_Method_Id, Name, Prefix, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) " +;
                "VALUES (4, 'Deposito bancario', 'db', 1, 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar Deposito bancario.")
     ENDIF
     DeleteFileLock()
   ENDIF    

    GsQueryInsert := "INSERT INTO Pay_Method (Pay_Method_Id, Name, Prefix, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) " +;
            "VALUES (5, 'Transferencia', 'tr',1, 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar Transferencia")
     ENDIF
     DeleteFileLock()
   ENDIF    

    GsQueryInsert := "INSERT INTO Pay_Method (Pay_Method_Id, Name, Prefix, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) " +;
                "VALUES (6, 'Pay Pal', 'pp', 1, 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar Pay Pal.")
     ENDIF
     DeleteFileLock()
   ENDIF    

    GsQueryInsert := "INSERT INTO Pay_Method (Pay_Method_Id, Name, Prefix, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) " +;
            "VALUES (7, 'Efectivo', 'ef', 0, 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar Efectivo.")
     ENDIF
     DeleteFileLock()
   ENDIF       
    
    GsQueryInsert := "INSERT INTO Pay_Method (Pay_Method_Id, Name, Prefix, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) " +;
            "VALUES (8, 'Nota credito', 'nc', 1, 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar Nota credito.")
     ENDIF
     DeleteFileLock()
   ENDIF       

    GsQueryInsert := "INSERT INTO Pay_Method (Pay_Method_Id, Name, Prefix,  Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) " +;
            "VALUES (9, 'Payu', 'py', 1, 1, 'Manual', 'sa',&GdDateSQL, &GsTimeSQL)"
   IF TryToLock()
     IF .NOT. BeforeSave(GsQueryInsert)
        MsgExclamation ("Error al tratar de insertar Payu.")
     ENDIF
     DeleteFileLock()
   ENDIF
 
// Pay method 

  
    GsQueryInsert := "INSERT INTO PAY_METHOD (Pay_Method_Id, Name, Prefix, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (10, 'Pago con balance', 'bal', 1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  
    
    GsQueryInsert := "INSERT INTO PAY_METHOD (Pay_Method_Id, Name, Prefix, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (11, 'Terminal punto de venta', 'tpv', 1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF      
  
    GsQueryInsert := "INSERT INTO PAY_METHOD (Pay_Method_Id, Name, Prefix, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (9, 'BCoin', 'bco', 1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF
  
    GsQueryInsert := "INSERT INTO PAY_METHOD (Pay_Method_Id, Name, Prefix, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (100, 'Servicios electronicos', 'serelec', 1, 0,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  

    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (1, 'Carga inicial inventario', 1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  

    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (2, 'Compra', 1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  

    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (3, 'Devolucion', 1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  

    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (4, 'Defecto', 1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  

    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (5, 'Cambio', 1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  

    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (6, 'Transferencia', 1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  

    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (7, 'Ajuste', 1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF 
  
    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (100, 'Ajuste', -1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  

    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (101, 'Merma', -1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  

    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (102, 'Robo', -1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  

    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (103, 'Cambio', -1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  

    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (104, 'Transferencia', -1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  

    GsQueryInsert := "INSERT INTO Kardex_Type (Kardex_Type_Id, Name, Nature, Is_Visible, Prog_Name, Sys_User_Id, Entry_Date, Entry_Time) "
    GsQueryInsert += "VALUES (103, 'Devolucion', -1, 1,  'Manual', 'sa', &GdDateSQL, &GsTimeSQL)" 
  IF TryToLock() 
    IF .NOT. BeforeSave(GsQueryInsert)
      MsgExclamation ("Error al tratar de insertar, actualizar o borrar dato.")
     ENDIF 
     DeleteFileLock()
  ENDIF  



  
   ClearMsg()
   MsgInfo("Fin de insertar folios del sistema", "FIN")    
   RETURN
