#INCLUDE <hmg.ch>
#INCLUDE <PS_Posoft.ch>

PROCEDURE ShowItems
   SET TOOLTIPSTYLE BALLOON
   
   IF IsWindowActive (Frm_ShowItem)
      MsgStop("Ya esta en en uso esta opcin","ERROR")
      RETURN NIL
   ELSE
      LOAD WINDOW Frm_ShowItem
      END WINDOW
      GsItemId := ""
      GetAllItems()
      aGetTableData := {}
      CENTER WINDOW Frm_ShowItem
      ACTIVATE WINDOW Frm_ShowItem
   ENDIF

   PROCEDURE GetAllItems
      GsReadQuery := "SELECT Item_Cd, Name, Unit_Measure_Base, Picture_Path "
      GsReadQuery += "FROM item WHERE Is_Visible = 1 "
      GsReadQuery += "ORDER BY Name" 

      IF TryToLock()
         aGetTableData := ReadData (GsReadQuery)
         DeleteFileLock()
      ENDIF
                    
       IF LEN (aGetTableData) = 0
         MsgExclamation ("No hay articulos de ese que mostrar")
         RETURN
      ELSE     
         FillGridItems()
      ENDIF
   RETURN

PROCEDURE FillGridItems
	Frm_ShowItem.Grd_Items.DeleteAllItems
	FOR i := 1 to LEN (aGetTableData)
		Frm_ShowItem.Grd_Items.AddItem ({ ALLTRIM(aGetTableData[i,1]), +;
			ALLTRIM(aGetTableData[i,2]), +;
			ALLTRIM(aGetTableData[i,3]), +;     
			aGetTableData[i,4] })
	NEXT i
	Frm_ShowItem.Grd_Items.Value := 1
	Frm_ShowItem.Grd_Items.SetFocus
RETURN

PROCEDURE GetItems
  GsData1 := ColumnGridValue("Grd_Items", "Frm_ShowItem", 1)
  GsData2 := ColumnGridValue("Grd_Items", "Frm_ShowItem", 2)
  GsData3 := ColumnGridValue("Grd_Items", "Frm_ShowItem", 3)     
  GsData4 := ColumnGridValue("Grd_Items", "Frm_ShowItem", 4) 
	ExitShowItems()
RETURN

   PROCEDURE FindDataItems
      GsReadQuery := "SELECT Item_Cd, Name, Unit_Measure_Base, Picture_Path "
      GsReadQuery += "FROM item WHERE Is_Visible = 1 AND Name LIKE '%" 
      GsReadQuery += ALLTRIM(Frm_ShowItem.Txt_IndividualData.VALUE) + "%' "
      GsReadQuery += " ORDER BY Name"
      
      IF TryToLock()
         aGetTableData := ReadData (GsReadQuery)
         DeleteFileLock()
      ENDIF
                    
      IF LEN (aGetTableData) = 0
         MsgExclamation ("No hay articulos que mostrar")
         RETURN
      ELSE  
         FillGridItems()
      ENDIF
      
   RETURN

   PROCEDURE ExitShowItems
      Frm_ShowItem.Release
   RETURN

RETURN
