﻿#INCLUDE <hmg.ch>
#INCLUDE "hbver.ch"
#INCLUDE <PS_Posoft.ch>

PROCEDURE ShowPurchaseOrder
  PRIVATE LnPurchaseStatusId := LnProviderId := LnPurchasId := 0
  LsPOReport := ""
  LoadMyData()
  SET TOOLTIPSTYLE BALLOON
  IF IsWindowActive (Frm_ShowPurchaseOrder)
    MsgStop("Ya esta en en uso esta opci�n","ERROR")
    RETURN NIL
  ELSE
    LOAD WINDOW Frm_ShowPurchaseOrder
    END WINDOW
  IF .NOT. ConectMe()
    RETURN
  ENDIF
    POSwitch()
    CENTER WINDOW Frm_ShowPurchaseOrder
    ACTIVATE WINDOW Frm_ShowPurchaseOrder
  ENDIF

  PROCEDURE POSwitch
    Frm_ShowPurchaseOrder.Txt_POStatus.Value := ""
    Frm_ShowPurchaseOrder.Txt_ProviderName.Value := ""
    Frm_ShowPurchaseOrder.Dp_InitialDate.Value := DATE()
    Frm_ShowPurchaseOrder.Btn_FindPOStatus.SetFocus
  RETURN

  PROCEDURE FindPOStatus
    Frm_ShowPurchaseOrder.Txt_POStatus.Value := ""
    GnData1 := 0
    GsData1 := ""
    ShowStandardStatus(6)
    LnPurchaseStatusId := GnData1
    Frm_ShowPurchaseOrder.Txt_POStatus.Value := GsData1
    GetDataForThisStatus()
    Frm_ShowPurchaseOrder.Dp_InitialDate.SetFocus
  RETURN

  PROCEDURE FindPOProvider
    GnData1 := 0
    GsData1 := ""
    ShowProvider()
    LnProviderId := GnData1
    Frm_ShowPurchaseOrder.Txt_ProviderName.Value := GsData1
    Frm_ShowPurchaseOrder.Btn_Accepted.SetFocus
  RETURN

  PROCEDURE GetDataForThisStatus
// Obtengo la ultima fecha de la orden de compra
		GsReadQuery := "SELECT MAX(STRFTIME('%d/%m/%Y',PURCHASE_DATE)) FROM "
      GsReadQuery += "PURCHASE where Purchase_Status_Id = "+C2SQL(LnPurchaseStatusId)
		IF TryToLock()
		   oPurchase := sql(oDataBase,GsReadQuery)
		   DeleteFileLock()
		ELSE
		   RETURN
		ENDIF

		IF LEN (oPurchase) > 0
		   LdLastPO := CTOD(oPurchase[1,1])
		   LdInitialPO := LdLastPO - 30
		   Frm_ShowPurchaseOrder.Dp_EndingDate.Value := LdLastPO
		   Frm_ShowPurchaseOrder.Dp_InitialDate.Value := LdInitialPO
		ENDIF
  RETURN

  PROCEDURE FillGridPOStatus
    Frm_ShowPurchaseOrder.Grd_PurchaseOrder.DeleteAllItems
    Frm_ShowPurchaseOrder.Grd_PODetail.DeleteAllItems
    Frm_ShowPurchaseOrder.Edt_PONote.Value := ""
//    IF EMPTY(Frm_ShowPurchaseOrder.Txt_POStatus.Value)
//      MsgInfo("Selecciona el estatus de la orden de compra a buscar","Condicion invalida")
//      Frm_ShowPurchaseOrder.Btn_FindPOStatus.SetFocus
//      RETURN
//    ENDIF

    IF Frm_ShowPurchaseOrder.Dp_InitialDate.Value > Frm_ShowPurchaseOrder.Dp_EndingDate.Value
      MsgInfo("La fecha inicial debe ser menor a la fecha final, corrige e intanta de nuevo","Condicion invalid")
      Frm_ShowPurchaseOrder.Dp_InitialDate.SetFocus
      RETURN
    ENDIF

    IF EMPTY(Frm_ShowPurchaseOrder.Txt_ProviderName.Value)
      LnProviderId := 0
    ENDIF
      PutMsg("Espera... buscando ordenes con ese criterio.")
      Frm_ShowPurchaseOrder.Grd_PurchaseOrder.DeleteAllItems
      LsPOReport := ""
      GsReadQuery := "SELECT pu.Purchase_Id, "
      GsReadQuery += "pu.Provider_Id, "
      GsReadQuery += "p.Name, "
      GsReadQuery += "pu.Purchase_Type_Id, "
      GsReadQuery += "pu.Purchase_Status_Id, "
      GsReadQuery += "STRFTIME('%d/%m/%Y',pu.Purchase_Date), "
      GsReadQuery += "pu.Total_Gross, "
      GsReadQuery += "pu.Total_Discount, "
      GsReadQuery += "pu.Total_Tax, "
      GsReadQuery += "pu.Gran_Total, "
      GsReadQuery += "pu.Delivery_Day, "
      GsReadQuery += "pu.Standard_Status_Id, "
      GsReadQuery += "pu.Purchase_Year, "
      GsReadQuery += "pu.Purchase_Month, "
      GsReadQuery += "pu.Purchase_Day, "
      GsReadQuery += "pu.Credit_Day, "
      GsReadQuery += "pu.Note, "
      GsReadQuery += "ss.Name "
      GsReadQuery += "FROM Purchase pu "
      GsReadQuery += "INNER JOIN Provider p ON p.Provider_Id = pu.Provider_Id "
      GsReadQuery += "INNER JOIN standard_Status ss ON ss.Standard_Status_ID = pu.Standard_Status_Id "
      GsReadQuery += "WHERE ss. module_ID = 6 "
//      GsReadQuery += "WHERE pu.Purchase_Status_Id = " + C2SQL(LnPurchaseStatusId)
      GsReadQuery += " AND STRFTIME('%d/%m/%Y',pu.Purchase_Date) BETWEEN "
      GsReadQuery += C2SQL(Frm_ShowPurchaseOrder.Dp_InitialDate.Value)
      GsReadQuery += " AND " + C2SQL(Frm_ShowPurchaseOrder.Dp_EndingDate.Value)

      IF EMPTY(Frm_ShowPurchaseOrder.Txt_POStatus.Value)
         GsReadQuery += " AND pu.Purchase_Status_id >=0 "
      ELSE
         GsReadQuery += " AND pu.Purchase_Status_Id = " + C2SQL(LnPurchaseStatusId)
      ENDIF

      IF EMPTY(Frm_ShowPurchaseOrder.Txt_ProviderName.Value)
        GsReadQuery += " AND pu.Provider_Id > " + C2SQL(LnProviderId)
      ELSE
        GsReadQuery += " AND pu.Provider_Id = " + C2SQL(LnProviderId)
      ENDIF
      GsReadQuery += " ORDER BY pu.Purchase_Id"
//     inputbox("Primero","Segundo",GsReadQuery)
      LsPOReport := GsReadQuery
      IF TryToLock()
        oPurchase := sql(oDataBase,GsReadQuery)
        DeleteFileLock()
      ELSE
        RETURN
      ENDIF

      IF LEN (oPurchase) = 0
        ClearMsg()
        MsgExclamation ("No hay ordenes de compra con ese criterio de busqueda.")
        RETURN
      ELSE
        Frm_ShowPurchaseOrder.Grd_PurchaseOrder.DeleteAllItems
        FOR i := 1 to LEN (oPurchase)
          Frm_ShowPurchaseOrder.Grd_PurchaseOrder.AddItem ({ ALLTRIM(STR(oPurchase[i,1])),+;
           ALLTRIM(oPurchase[i,3]), oPurchase[i,6], +;
           TRANSFORM(VAL(oPurchase[i,7]),"$999,999,999.99"), +;
           TRANSFORM(VAL(oPurchase[i,8]),"$999,999,999.99"), +;
           TRANSFORM(VAL(oPurchase[i,9]),"$999,999,999.99"), +;
           TRANSFORM(VAL(oPurchase[i,10]),"$999,999,999.99"), +;
           ALLTRIM(oPurchase[i,17]),  ALLTRIM(oPurchase[i,18]) })
        NEXT i
      ENDIF

      ClearMsg()
      Frm_ShowPurchaseOrder.Grd_PurchaseOrder.Value := 1
      Frm_ShowPurchaseOrder.Grd_PurchaseOrder.SetFocus
  RETURN

  PROCEDURE GetPODetail
    Frm_ShowPurchaseOrder.Grd_PODetail.DeleteAllItems
    Frm_ShowPurchaseOrder.Edt_PONote.Value := ""
    LnPurchasId := C2SQL(VAL(ColumnGridValue( "Grd_PurchaseOrder", "Frm_ShowPurchaseOrder", 1)))
    PutMsg("Espera... buscando detalle de la orden de compra seleccionad.")
    GsReadQuery := "SELECT pi.Item_Cd, "
    GsReadQuery += "i.Name, "
    GsReadQuery += "pi.Qty_Requested, "
    GsReadQuery += "pi.Cost, "
    GsReadQuery += "pi.Gross, "
    GsReadQuery += "pi.Disct_Percent, "
    GsReadQuery += "pi.Disct_Amount, "
    GsReadQuery += "pi.Sub_Total, "
    GsReadQuery += "pi.Tax_Percent, "
    GsReadQuery += "pi.Total_Tax, "
    GsReadQuery += "pi.Total_Item, "
    GsReadQuery += "pi.Revision, "
    GsReadQuery += "p.Note "
    GsReadQuery += "FROM Purchase p "
    GsReadQuery += "INNER JOIN Purchase_item pi on pi.Purchase_id = p.Purchase_Id "
    GsReadQuery += "INNER JOIN ITEM i ON i.Item_Cd = pi.Item_Cd "
    GsReadQuery += "WHERE pi.Purchase_Id = " + C2SQL(LnPurchasId)

    IF TryToLock()
      oPurchaseDetail := sql(oDataBase,GsReadQuery)
      DeleteFileLock()
    ELSE
      RETURN
    ENDIF

    IF LEN (oPurchaseDetail) = 0
      MsgExclamation ("No hay detalle de la orden de compra.")
      RETURN
    ELSE
      FOR i := 1 to LEN (oPurchaseDetail)
        Frm_ShowPurchaseOrder.Grd_PODetail.AddItem ({ ALLTRIM(oPurchaseDetail[i,1]), +;
        ALLTRIM(oPurchaseDetail[i,2]), +;
        TRANSFORM(VAL(oPurchaseDetail[i,3]),"999,999.99"), +;
        TRANSFORM(VAL(oPurchaseDetail[i,4]),"$999,999,999.99"), +;
        TRANSFORM(VAL(oPurchaseDetail[i,5]),"$999,999,999.99"), +;
        TRANSFORM(VAL(oPurchaseDetail[i,6]),"%99.99"), +;
        TRANSFORM(VAL(oPurchaseDetail[i,7]),"$999,999,999.99"), +;
        TRANSFORM(VAL(oPurchaseDetail[i,8]),"$999,999,999.99"), +;
        TRANSFORM(VAL(oPurchaseDetail[i,9]),"%99.99"), +;
        TRANSFORM(VAL(oPurchaseDetail[i,10]),"$999,999,999.99"), +;
        TRANSFORM(VAL(oPurchaseDetail[i,11]),"$999,999,999.99"), +;
        oPurchaseDetail[i,12] })
      NEXT i
      Frm_ShowPurchaseOrder.Edt_PONote.Value := oPurchaseDetail[1,13]
    ENDIF
    ClearMsg()
  RETURN

  PROCEDURE GoPrintPO
    LnPurchasId := C2SQL(VAL(ColumnGridValue( "Grd_PurchaseOrder", "Frm_ShowPurchaseOrder", 1)))
    PrintPurchaseOrder(LnPurchasId)
  RETURN

  PROCEDURE GoPrintPOReport
   PrintPurchaseOrderReport(LsPOReport, Frm_ShowPurchaseOrder.Txt_POStatus.Value)
  RETURN

  PROCEDURE ExitPO
    Frm_ShowPurchaseOrder.Release
  RETURN
RETURN